/*
 * 8 avril 2007
 * 
 * SCALP - Système de Cartographie Automatique Libre pour la Pédagogie
 * Version beta 0.94
 *
 * Copyright 1997-2007 Université de Toulouse Le Mirail / Département de Géographie / Laurent Jégou
 * Portions : 	Copyright (c) 2004 Sun Microsystems (file filter, AbstractLayout)
 * 				Copyright 1999, 2000, 2001, 2002 by Bruno Lowagie (iText pdf exports)
 * 				Copyright (C) 2001 Andrew Khan (jxl import/export format Excelé)
 * http://www.univ-tlse2.fr/geoprdc
 * jegou@univ-tlse2.fr
 * 
 * Ce programme est un logiciel libre régi par la licence CeCILL (cf. lien ci-dessous), cette licence confére
 * aux utilisateurs la liberté de modification et de redistribution du logiciel, dans le cadre d'un modéle de
 * diffusion open-source.
 * L'exercice de ces libertés est assorti de certains devoirs é la charge des utilisateurs afin de préserver
 * ce statut au cours des redistributions ultérieures.
 * Léaccessibilité au code source et les droits de copie, de modification et de redistribution qui en découlent
 * ont pour contrepartie de néoffrir aux utilisateurs quéune garantie limitée et de ne faire peser sur léauteur
 * le titulaire des droits patrimoniaux et les concédants successifs quéune responsabilité restreinte.
 * 
 * Le texte intégral de la licence se trouve dans la disribution, ou é l'adresse suivante :
 * http://www.cecill.info
 */

package guiInterface;

import java.awt.Color;
import java.awt.event.ActionEvent;
import java.util.Arrays;
import java.util.Vector;
import javax.swing.JOptionPane;
import javax.swing.JRadioButton;
import javax.swing.JTextField;

import java.text.DecimalFormat;

import carto.Carte;
import carto.ClasseDiscret;
import donnees.champDonnees;

/**
 * 
 * @author Laurent
 */

public class BoiteDialogueChoroCouleur extends javax.swing.JDialog {

	private FenetrePrincipale base;

	private DecimalFormat form = new DecimalFormat("#,##0.00;(#,##0.00)"); // Arrondi d'affichage é deux décimales. 

	private cs_quadri CS_CMYK;

	private javax.swing.ButtonGroup buttonGroup1;

	private javax.swing.ButtonGroup buttonGroup2;

	private javax.swing.JLabel Caisson1;

	private javax.swing.JLabel Caisson2;

	private javax.swing.JLabel Caisson3;

	private javax.swing.JLabel Caisson4;

	private javax.swing.JLabel Caisson5;

	private javax.swing.JLabel Caisson6;

	private javax.swing.JLabel Caisson7;

	private javax.swing.JLabel Caisson8;

	private int caissonSelectionne = 1;

	public Vector colonnes;

	private javax.swing.JLabel cyanLabel;

	private javax.swing.JSlider cyanSlider;

	public Vector data;

	private javax.swing.JLabel jauneLabel;

	private javax.swing.JSlider jauneSlider;

	private javax.swing.JButton jBAnnuler;

	private javax.swing.JButton jBDBleu;

	private javax.swing.JButton jBDegrade;

	private javax.swing.JButton jBDGris;

	private javax.swing.JButton jBDRouge;

	private javax.swing.JButton jBDVert;

	private javax.swing.JButton jBGraphique;

	private javax.swing.JButton jBInversion;

	private javax.swing.JButton jBLAuto;

	private javax.swing.JButton jBLFonte;

	private javax.swing.JButton jBOk;

	private javax.swing.JButton jButton10;

	private javax.swing.JButton jButton11;

	private javax.swing.JButton jButton12;

	private javax.swing.JButton jButton13;

	private javax.swing.JButton jButton14;

	private javax.swing.JComboBox jComboBox1;

	private javax.swing.JLabel jLabel1;

	private javax.swing.JLabel jLabel2;

	private javax.swing.JLabel jLabel20;

	private javax.swing.JLabel jLabel21;

	private javax.swing.JLabel jLabel22;

	private javax.swing.JLabel jLabel23;

	private javax.swing.JLabel jLabel3;

	private javax.swing.JLabel jLabel32;

	private javax.swing.JLabel jLabel33;

	private javax.swing.JLabel jLabel34;

	private javax.swing.JLabel jLabel35;

	private javax.swing.JLabel jLabel43;

	private javax.swing.JLabel jLabel44;

	private javax.swing.JLabel jLabel45;

	private javax.swing.JLabel jLabel46;

	private javax.swing.JLabel jLabel47;

	private javax.swing.JLabel jLabel48;

	private javax.swing.JLabel jLabel49;

	private javax.swing.JLabel jLD1;

	private javax.swing.JLabel jLD2;

	private javax.swing.JLabel jLD3;

	private javax.swing.JLabel jLD4;

	private javax.swing.JLabel jLD5;

	private javax.swing.JLabel jLD6;

	private javax.swing.JLabel jLD7;

	private javax.swing.JLabel jLD8;

	private javax.swing.JLabel jLL1;

	private javax.swing.JLabel jLL2;

	private javax.swing.JLabel jLL3;

	private javax.swing.JLabel jLL4;

	private javax.swing.JLabel jLL5;

	private javax.swing.JLabel jLL6;

	private javax.swing.JLabel jLL7;

	private javax.swing.JLabel jLL8;

	private javax.swing.JLabel jln1;

	private javax.swing.JLabel jln2;

	private javax.swing.JLabel jln3;

	private javax.swing.JLabel jln4;

	private javax.swing.JLabel jln5;

	private javax.swing.JLabel jln6;

	private javax.swing.JLabel jln7;

	private javax.swing.JLabel jln8;

	private javax.swing.JLabel jlp1;

	private javax.swing.JLabel jlp2;

	private javax.swing.JLabel jlp3;

	private javax.swing.JLabel jlp4;

	private javax.swing.JLabel jlp5;

	private javax.swing.JLabel jlp6;

	private javax.swing.JLabel jlp7;

	private javax.swing.JLabel jlp8;

	private javax.swing.JPanel jPanel1;

	private javax.swing.JPanel jPanel2;

	private javax.swing.JPanel jPanel3;

	private javax.swing.JPanel jPanel4;

	private javax.swing.JPanel jPanel5;

	private javax.swing.JRadioButton jRadioButton1;

	private javax.swing.JRadioButton jRadioButton2;

	private javax.swing.JRadioButton jRadioButton3;

	private javax.swing.JRadioButton jRadioButton4;

	private javax.swing.JRadioButton jRadioButton5;

	private javax.swing.JRadioButton jRadioButton6;

	private javax.swing.JRadioButton jrbc1;

	private javax.swing.JRadioButton jrbc2;

	private javax.swing.JRadioButton jrbc3;

	private javax.swing.JRadioButton jrbc4;

	private javax.swing.JRadioButton jrbc5;

	private javax.swing.JRadioButton jrbc6;

	private javax.swing.JRadioButton jrbc7;

	private javax.swing.JRadioButton jrbc8;

	private javax.swing.JSeparator jSeparator1;

	private javax.swing.JSeparator jSeparator2;

	private javax.swing.JSeparator jSeparator3;

	private javax.swing.JSlider jSlider1;

	private javax.swing.JTabbedPane jTabbedPane1;

	private javax.swing.JTextField jTextField1;

	private javax.swing.JTextField jTextField2;

	private javax.swing.JTextField jTextField24;

	private javax.swing.JTextField jTextField25;

	private javax.swing.JTextField jTextField26;

	private javax.swing.JTextField jtfc1max;

	private javax.swing.JTextField jtfc1min;

	private javax.swing.JTextField jtfc2max;

	private javax.swing.JTextField jtfc2min;

	private javax.swing.JTextField jtfc3max;

	private javax.swing.JTextField jtfc3min;

	private javax.swing.JTextField jtfc4max;

	private javax.swing.JTextField jtfc4min;

	private javax.swing.JTextField jtfc5max;

	private javax.swing.JTextField jtfc5min;

	private javax.swing.JTextField jtfc6max;

	private javax.swing.JTextField jtfc6min;

	private javax.swing.JTextField jtfc7max;

	private javax.swing.JTextField jtfc7min;

	private javax.swing.JTextField jtfc8max;

	private javax.swing.JTextField jtfc8min;

	private javax.swing.JTextField jtfl1;

	private javax.swing.JTextField jtfl2;

	private javax.swing.JTextField jtfl3;

	private javax.swing.JTextField jtfl4;

	private javax.swing.JTextField jtfl5;

	private javax.swing.JTextField jtfl6;

	private javax.swing.JTextField jtfl7;

	private javax.swing.JTextField jtfl8;

	private javax.swing.JLabel magentaLabel;

	private javax.swing.JSlider magentaSlider;

	private boolean modif;

	private javax.swing.JLabel nbClassesLabel;

	private javax.swing.JLabel noirLabel;

	private javax.swing.JSlider noirSlider;
	
	private javax.swing.JRadioButton jrbcm1;
	
	private javax.swing.JRadioButton jrbcm2;
	
	private javax.swing.JRadioButton jrbcm3;
	
	private javax.swing.ButtonGroup bgcm;

	private Carte tempCarte;

	/** Creates new form ChoroCouleur */
	public BoiteDialogueChoroCouleur(FenetrePrincipale parent, boolean modal, String titre, Vector champs, Vector table) {
		super(parent, titre, modal);
		boolean defaut = false;
		this.setResizable(false);
		this.colonnes = champs;
		this.data = table;
		this.base = parent;
		this.tempCarte = (Carte) base.carte.copie();
		//this.tempCarte.setTypeAnalyse(1);
		if (tempCarte.analysePlages.champNum == -1) {//Valeurs par défaut si pas de carte
			// existante
			int i = 0;
			defaut = true;
			for (i = 0; i < colonnes.size(); i++) {
				int ti = ((champDonnees) colonnes.get(i)).typeI;
				if (ti == 0 || ti == 2) {
					tempCarte.analysePlages.champNum = i;
					break;
				}
			}
			tempCarte.analysePlages.typeDiscret = 0;
			defautCouleurs();
			disecQuantiles();
		}
		this.CS_CMYK = new cs_quadri();
		initComponents();
		caissonSelectionne = 1;
		changeCurseurs();
	}

	private void Caisson1MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_Caisson1MouseClicked
		caissonSelectionne = 1;
		jrbc1.setSelected(true);
		changeCurseurs();
	}

	private void Caisson2MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_Caisson2MouseClicked
		caissonSelectionne = 2;
		jrbc2.setSelected(true);
		changeCurseurs();
	}

	private void Caisson3MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_Caisson3MouseClicked
		if (tempCarte.analysePlages.nbreClasses < 3)
			return;
		caissonSelectionne = 3;
		jrbc3.setSelected(true);
		changeCurseurs();
	}

	private void Caisson4MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_Caisson4MouseClicked
		if (tempCarte.analysePlages.nbreClasses < 4)
			return;
		caissonSelectionne = 4;
		jrbc4.setSelected(true);
		changeCurseurs();
	}

	private void Caisson5MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_Caisson5MouseClicked
		if (tempCarte.analysePlages.nbreClasses < 5)
			return;
		caissonSelectionne = 5;
		jrbc5.setSelected(true);
		changeCurseurs();
	}

	private void Caisson6MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_Caisson6MouseClicked
		if (tempCarte.analysePlages.nbreClasses < 6)
			return;
		caissonSelectionne = 6;
		jrbc6.setSelected(true);
		changeCurseurs();
	}

	private void Caisson7MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_Caisson7MouseClicked
		if (tempCarte.analysePlages.nbreClasses < 7)
			return;
		jrbc7.setSelected(true);
		caissonSelectionne = 7;
		changeCurseurs();
	}

	private void Caisson8MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_Caisson8MouseClicked
		if (tempCarte.analysePlages.nbreClasses < 8)
			return;
		caissonSelectionne = 8;
		jrbc8.setSelected(true);
		changeCurseurs();
	}

	private void changeCouleurCaissonSelectionne() {
		if (modif == true)
			return; //Permet d'éviter une rétroaction récursive
		float[] composantes = new float[] {(float)cyanSlider.getValue() / 255, (float)jauneSlider.getValue() / 255, (float)magentaSlider.getValue() / 255, (float)noirSlider.getValue() / 255};
		float[] nrgb = CS_CMYK.toRGB(composantes);
		Color c = new Color(nrgb[0], nrgb[1], nrgb[2]);
		switch (caissonSelectionne) {
		case 1:
			Caisson1.setBackground(c);
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(0)).couleur = Caisson1.getBackground();
			break;
		case 2:
			Caisson2.setBackground(c);
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(1)).couleur = Caisson2.getBackground();
			break;
		case 3:
			Caisson3.setBackground(c);
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(2)).couleur = Caisson3.getBackground();
			break;
		case 4:
			Caisson4.setBackground(c);
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(3)).couleur = Caisson4.getBackground();
			break;
		case 5:
			Caisson5.setBackground(c);
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(4)).couleur = Caisson5.getBackground();
			break;
		case 6:
			Caisson6.setBackground(c);
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(5)).couleur = Caisson6.getBackground();
			break;
		case 7:
			Caisson7.setBackground(c);
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(6)).couleur = Caisson7.getBackground();
			break;
		case 8:
			Caisson8.setBackground(c);
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(7)).couleur = Caisson8.getBackground();
			break;
		}
	}

	private void changeCurseurs() {
		modif = true; //Blocage de l'appel du changement des couleurs
		float[] CMJN = new float[] {0, 0, 0, 0};
		getCaisson(caissonSelectionne).getBackground().getColorComponents(CS_CMYK, CMJN);
		cyanSlider.setValue((int)(CMJN[0] * 255));
		cyanLabel.setText(form.format((double)cyanSlider.getValue() / 255));
		magentaSlider.setValue((int)(CMJN[2] * 255));
		magentaLabel.setText(form.format((double)magentaSlider.getValue() / 255));
		jauneSlider.setValue((int)(CMJN[1] * 255));
		jauneLabel.setText(form.format((double)jauneSlider.getValue() / 255));
		noirSlider.setValue((int)(CMJN[3] * 255));
		noirLabel.setText(form.format((double)noirSlider.getValue() / 255));
		modif = false;
	}

	private void cyanSliderStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_rougeSliderStateChanged
		cyanLabel.setText(form.format((double)cyanSlider.getValue() / 255));
		changeCouleurCaissonSelectionne();
	}

	private void defautCouleurs() {
		Color ca = new Color(230, 240, 255);
		Color cb = new Color(0, 40, 80);
		((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(0)).couleur = ca;
		((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(tempCarte.analysePlages.nbreClasses - 1)).couleur = cb;
		int i = 0;
		int c1R = 230;
		int c1V = 240;
		int c1B = 255;
		int degradeRouge = (0 - c1R);
		int degradeVert = (40 - c1V);
		int degradeBleu = (80 - c1B);
		float cR = degradeRouge / tempCarte.analysePlages.nbreClasses;
		float cV = degradeVert / tempCarte.analysePlages.nbreClasses;
		float cB = degradeBleu / tempCarte.analysePlages.nbreClasses;
		for (i = 1; i < (tempCarte.analysePlages.nbreClasses - 1); i++) {
			int nR = (int) (c1R + (cR * i));
			int nV = (int) (c1V + (cV * i));
			int nB = (int) (c1B + (cB * i));
			Color couleur = new Color(nR, nV, nB);
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(i)).couleur = couleur;
		}
	}

	private void disecEquivalences() {
		//Discrétisation équivalences : calcul des bornes et des tailles
		int i = 0;
		int nbCl = tempCarte.analysePlages.nbreClasses;
		int ni = data.size() / colonnes.size();
		double[] valeurs = getValeursTriees();
		double min = valeurs[0];
		double max = valeurs[ni - 1];
		double largeur = (max - min) / nbCl;
		int compteur = 0;
		int clec = 0;
		double debClec = 0;
		int dernier = 0;
		tempCarte.analysePlages.videClasses();
		//Calcul bornes pour des classes de méme largeur
		((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(0)).limiteInf = valeurs[0];
		debClec = valeurs[0];
		for (i = 0; i < ni; i++) {
			compteur += 1;
			dernier += 1;
			if (valeurs[i] > (debClec + largeur)) {
				((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(clec)).limiteSup = valeurs[i];
				((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(clec)).nbreIndividus = compteur - 1;
				((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(clec)).partIndividus = (compteur - 1) * 100 / ni;
				compteur = 0;
				debClec = valeurs[i];
				if (clec < (nbCl - 1))
					clec += 1;
				else
					break;
				((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(clec)).limiteInf = valeurs[i];
			}
		}
		if ((clec - 1) < (nbCl - 2)) {
			int diff = (nbCl - 2) - (clec - 1);
			for (i = 0; i < diff; i++) {
				((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(clec + i)).limiteInf = valeurs[ni - 1];
				((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(clec + i)).limiteSup = valeurs[ni - 1];
				((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(clec + i)).nbreIndividus = 0;
				((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(clec + i)).partIndividus = 0;
			}
		}
		((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(nbCl - 1)).limiteInf = ((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(nbCl - 2)).limiteSup;
		((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(nbCl - 1)).limiteSup = valeurs[ni - 1];
		((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(nbCl - 1)).nbreIndividus = (ni - dernier + 1);
		((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(nbCl - 1)).partIndividus = (ni - dernier + 1) * 100 / ni;
	}

	private void disecMoyennes() {
		//Discrétisation moyennes
		int i = 0;
		int nbCl = tempCarte.analysePlages.nbreClasses;
		int ni = data.size() / colonnes.size();
		tempCarte.analysePlages.videClasses();
		int compteur = 0;
		double[] valeurs = getValeursTriees();
		double min = valeurs[0];
		double max = valeurs[ni - 1];
		double M = 0;
		double Ma = 0, Ma1 = 0, Ma2 = 0;
		double Mb = 0, Mb1 = 0, Mb2 = 0;
		int Mi = 0;
		int Mai = 0, Ma1i = 0, Ma2i = 0;
		int Mbi = 0, Mb1i = 0, Mb2i = 0;
		//Modification si besoin est du nombre de classes
		if (nbCl != 4 && nbCl != 8) {
			if (Math.abs((nbCl - 4)) < Math.abs((nbCl - 8)))
				nbCl = 4;
			else
				nbCl = 8;
			jSlider1.setValue(nbCl);
		}
		M = getMoyenne(valeurs, 0, ni);
		Mi = getIndice(valeurs, M);
		Ma = getMoyenne(valeurs, 0, Mi);
		Mai = getIndice(valeurs, Ma);
		Ma1 = getMoyenne(valeurs, 0, Mai);
		Ma1i = getIndice(valeurs, Ma1);
		Ma2 = getMoyenne(valeurs, Mai, Mi);
		Ma2i = getIndice(valeurs, Ma2);
		Mb = getMoyenne(valeurs, Mi, ni);
		Mbi = getIndice(valeurs, Mb);
		Mb1 = getMoyenne(valeurs, Mi, Mbi);
		Mb1i = getIndice(valeurs, Mb1);
		Mb2 = getMoyenne(valeurs, Mbi, ni);
		Mb2i = getIndice(valeurs, Mb2);
		if (nbCl == 4) {
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(0)).limiteInf = min;
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(0)).limiteSup = valeurs[Mai];
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(0)).nbreIndividus = Mai - 1;
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(0)).partIndividus = (Mai - 1) * 100 / ni;
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(1)).limiteInf = valeurs[Mai];
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(1)).limiteSup = valeurs[Mi];
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(1)).nbreIndividus = (Mi - 1) - (Mai - 1);
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(1)).partIndividus = ((Mi - 1) - (Mai - 1)) * 100 / ni;
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(2)).limiteInf = valeurs[Mi];
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(2)).limiteSup = valeurs[Mbi];
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(2)).nbreIndividus = (Mbi - 1) - (Mi - 1);
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(2)).partIndividus = ((Mbi - 1) - (Mi - 1)) * 100 / ni;
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(3)).limiteInf = valeurs[Mbi];
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(3)).limiteSup = max;
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(3)).nbreIndividus = ni - (Mbi - 1);
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(3)).partIndividus = (ni - (Mbi - 1)) * 100 / ni;
		}
		if (nbCl == 8) {
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(0)).limiteInf = min;
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(0)).limiteSup = valeurs[Ma1i];
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(0)).nbreIndividus = Ma1i - 1;
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(0)).partIndividus = (Ma1i - 1) * 100 / ni;
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(1)).limiteInf = valeurs[Ma1i];
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(1)).limiteSup = valeurs[Mai];
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(1)).nbreIndividus = (Mai - 1) - (Ma1i - 1);
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(1)).partIndividus = ((Mai - 1) - (Ma1i - 1)) * 100 / ni;
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(2)).limiteInf = valeurs[Mai];
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(2)).limiteSup = valeurs[Ma2i];
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(2)).nbreIndividus = (Ma2i - 1) - (Mai - 1);
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(2)).partIndividus = ((Ma2i - 1) - (Mai - 1)) * 100 / ni;
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(3)).limiteInf = valeurs[Ma2i];
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(3)).limiteSup = valeurs[Mi];
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(3)).nbreIndividus = (Mi - 1) - (Ma2i - 1);
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(3)).partIndividus = ((Mi - 1) - (Ma2i - 1)) * 100 / ni;
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(4)).limiteInf = valeurs[Mi];
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(4)).limiteSup = valeurs[Mb1i];
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(4)).nbreIndividus = (Mb1i - 1) - (Mi - 1);
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(4)).partIndividus = ((Mb1i - 1) - (Mi - 1)) * 100 / ni;
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(5)).limiteInf = valeurs[Mb1i];
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(5)).limiteSup = valeurs[Mbi];
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(5)).nbreIndividus = (Mbi - 1) - (Mb1i - 1);
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(5)).partIndividus = ((Mbi - 1) - (Mb1i - 1)) * 100 / ni;
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(6)).limiteInf = valeurs[Mbi];
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(6)).limiteSup = valeurs[Mb2i];
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(6)).nbreIndividus = (Mb2i - 1) - (Mbi - 1);
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(6)).partIndividus = ((Mb2i - 1) - (Mbi - 1)) * 100 / ni;
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(7)).limiteInf = valeurs[Mb2i];
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(7)).limiteSup = max;
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(7)).nbreIndividus = ni - (Mb2i - 1);
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(7)).partIndividus = (ni - (Mb2i - 1)) * 100 / ni;
		}
	}

	private void disecNuages() {
		//Discrétisation nuages : calcul des bornes et des tailles
		int i = 0;
		int j = 0;
		int nbCl = tempCarte.analysePlages.nbreClasses;
		int ni = data.size() / colonnes.size();
		double[] valeurs = getValeursTriees();
		double min = valeurs[0];
		double max = valeurs[ni - 1];
		double moyenne = getMoyenne(valeurs, 0, valeurs.length);
		double ec = getEcType(valeurs);
		double[] moy = new double[nbCl];
		int debut = 0;
		int[] ap = new int[ni]; //Classe d'appartenance préférable
		double minDist = Double.MAX_VALUE; //Minima
		double distance = 0;
		double[] n1 = new double[nbCl];
		boolean variation = true;
		//Disec de départ : Quantiles
		disecQuantiles();
		int iterations = 0;
		while (variation == true) {
			iterations += 1;
			//Calcul des moyennes des premiéres classes
			debut = 0;
			for (i = 0; i < nbCl; i++) {
				int bout = debut + ((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(i)).nbreIndividus;
				if (bout == ni)
					bout = ni - 1;
				moy[i] = getMoyenne(valeurs, debut, bout);
				debut = bout;
			}
			//Calcul des distances é la moyenne
			for (i = 0; i < ni; i++) {
				ap[i] = 0;
				minDist = Double.MAX_VALUE;
				for (j = 0; j < nbCl; j++) {
					distance = Math.pow((moy[j] - valeurs[i]), 2);
					if (distance < minDist) {
						minDist = distance;
						ap[i] = j;
					}
				}
			}
			//Réaffectation des classes (largeurs)
			for (i = 0; i < nbCl; i++) {
				n1[i] = ((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(i)).nbreIndividus;
				((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(i)).nbreIndividus = 0;
			}
			for (i = 0; i < ni; i++) {
				((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(ap[i])).nbreIndividus += 1;
			}
			//Vérification de la variation
			variation = false;
			for (i = 0; i < nbCl; i++) {
				if (((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(i)).nbreIndividus != n1[i]) {
					variation = true;
					break;
				}
			}
		}
		//Paramétrage des nouvelles classes
		int compteur = 0;
		for (i = 0; i < nbCl; i++) {
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(i)).limiteInf = valeurs[compteur];
			compteur += ((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(i)).nbreIndividus;
			if (compteur == ni)
				compteur = ni - 1;
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(i)).limiteSup = valeurs[compteur];
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(i)).partIndividus = (((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(i)).nbreIndividus * 100)
			/ ni;
		}
	}

	private void disecQuantiles() {
		//Discrétisation quantiles : calcul des bornes et des tailles
		int i = 0;
		int nbCl = tempCarte.analysePlages.nbreClasses;
		int ni = data.size() / colonnes.size();
		int nipc = ni / nbCl;
		int reste = ni % nbCl;
		tempCarte.analysePlages.videClasses();
		//Calcul du nombre d'individus égal par classe
		for (i = 0; i < nbCl; i++) { //Répartition des individus dans les
			// classes
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(i)).nbreIndividus = nipc;
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(i)).partIndividus = nipc * 100 / ni;
		}
		for (i = 0; i < reste; i++) { //Répartition du reste éventuel
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(i)).nbreIndividus += 1;
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(i)).partIndividus = (nipc + 1) * 100 / ni;
		}
		//Calcul bornes
		int compteur = 0;
		double[] valeurs = getValeursTriees();
		for (i = 0; i < nbCl; i++) {
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(i)).limiteInf = valeurs[compteur];
			compteur += ((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(i)).nbreIndividus;
			if (compteur > (ni - 1))
				compteur = ni - 1;
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(i)).limiteSup = valeurs[compteur];
		}
	}

	private void disecManuelle() {
		int i = 0;
		int j = 0;
		int nbCl = tempCarte.analysePlages.nbreClasses;
		int ni = data.size() / colonnes.size();
		tempCarte.analysePlages.videClasses();
		double[] valeurs = getValeursTriees();
		int compteur = 0;
		for (i = 0; i < nbCl; i++) {
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(i)).limiteInf = Double.parseDouble(getjTFcmin(i + 1).getText());
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(i)).limiteSup = Double.parseDouble(getjTFcmax(i + 1).getText());        	
		}
		double e = Double.parseDouble(getjTFcmax(0).getText());
		for (i = 0; i < ni; i++) {
			if (valeurs[i] < (e)) {
				compteur += 1;
			} else {
				((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(j)).nbreIndividus = compteur;
				((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(j)).partIndividus = (compteur * 100 / valeurs.length);
				j += 1;
				if (j < nbCl) {
					e = Double.parseDouble(getjTFcmax(j).getText());
				} else {
					e = Double.parseDouble(getjTFcmax(j).getText()) + 1;
				}
				compteur = 0;
			}
		}

	}

	private void disecStandard() {
		//Discrétisation équivalences : calcul des bornes et des tailles
		int i = 0;
		int nbCl = tempCarte.analysePlages.nbreClasses;
		int ni = data.size() / colonnes.size();
		double[] valeurs = getValeursTriees();
		double min = valeurs[0];
		double max = valeurs[ni - 1];
		double moyenne = getMoyenne(valeurs, 0, valeurs.length);
		double ec = getEcType(valeurs);
		if ((moyenne - (ec / 2)) < valeurs[0])
			JOptionPane.showMessageDialog(this,
					Messages.getString("BoiteDialogueChoroCouleur.143"), Messages.getString("BoiteDialogueChoroCouleur.144"), JOptionPane.INFORMATION_MESSAGE); //$NON-NLS-1$ //$NON-NLS-2$
		if (nbCl != 3 && nbCl != 5 && nbCl != 7) {
			int ac3 = Math.abs((nbCl - 3));
			int ac5 = Math.abs((nbCl - 5));
			int ac7 = Math.abs((nbCl - 7));
			if (ac3 == Math.min(ac3, Math.min(ac5, ac7)))
				nbCl = 3;
			if (ac5 == Math.min(ac3, Math.min(ac5, ac7)))
				nbCl = 5;
			if (ac7 == Math.min(ac3, Math.min(ac5, ac7)))
				nbCl = 7;
			jSlider1.setValue(nbCl);
		}
		int compteur = 0;
		int compteurI = 0;
		switch (nbCl) {
		case 3:
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(0)).limiteInf = valeurs[0];
			while (valeurs[compteur] < (moyenne - (ec / 2))) {
				compteur += 1;
			}
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(0)).limiteSup = valeurs[compteur];
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(0)).nbreIndividus = compteur;
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(0)).partIndividus = (compteur * 100 / valeurs.length);
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(1)).limiteInf = valeurs[compteur];
			while (valeurs[compteur] < (moyenne + (ec / 2))) {
				compteur += 1;
				compteurI += 1;
			}
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(1)).limiteSup = valeurs[compteur];
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(1)).nbreIndividus = compteurI;
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(1)).partIndividus = (compteurI * 100 / valeurs.length);
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(2)).limiteInf = valeurs[compteur];
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(2)).limiteSup = valeurs[valeurs.length - 1];
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(2)).nbreIndividus = valeurs.length - compteur;
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(2)).partIndividus = ((valeurs.length - compteur) * 100 / valeurs.length);
			break;
		case 5:
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(0)).limiteInf = valeurs[0];
			while (valeurs[compteur] < (moyenne - (ec * 1.5))) {
				compteur += 1;
			}
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(0)).limiteSup = valeurs[compteur];
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(0)).nbreIndividus = compteur;
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(0)).partIndividus = (compteur * 100 / valeurs.length);
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(1)).limiteInf = valeurs[compteur];
			while (valeurs[compteur] < (moyenne - (ec / 2))) {
				compteur += 1;
				compteurI += 1;
			}
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(1)).limiteSup = valeurs[compteur];
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(1)).nbreIndividus = compteurI;
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(1)).partIndividus = (compteurI * 100 / valeurs.length);
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(2)).limiteInf = valeurs[compteur];
			compteurI = 0;
			while (valeurs[compteur] < (moyenne + (ec / 2))) {
				compteur += 1;
				compteurI += 1;
			}
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(2)).limiteSup = valeurs[compteur];
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(2)).nbreIndividus = compteurI;
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(2)).partIndividus = (compteurI * 100 / valeurs.length);
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(3)).limiteInf = valeurs[compteur];
			compteurI = 0;
			while (valeurs[compteur] < (moyenne + (ec * 1.5))) {
				compteur += 1;
				compteurI += 1;
			}
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(3)).limiteSup = valeurs[compteur];
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(3)).nbreIndividus = compteurI;
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(3)).partIndividus = (compteurI * 100 / valeurs.length);
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(4)).limiteInf = valeurs[compteur];
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(4)).limiteSup = valeurs[valeurs.length - 1];
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(4)).nbreIndividus = valeurs.length - compteur;
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(4)).partIndividus = ((valeurs.length - compteur) * 100 / valeurs.length);
			break;
		case 7:
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(0)).limiteInf = valeurs[0];
			while (valeurs[compteur] < (moyenne - (ec * 2.5))) {
				compteur += 1;
			}
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(0)).limiteSup = valeurs[compteur];
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(0)).nbreIndividus = compteur;
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(0)).partIndividus = (compteur * 100 / valeurs.length);
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(1)).limiteInf = valeurs[compteur];
			while (valeurs[compteur] < (moyenne - (ec * 1.5))) {
				compteur += 1;
				compteurI += 1;
			}
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(1)).limiteSup = valeurs[compteur];
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(1)).nbreIndividus = compteurI;
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(1)).partIndividus = (compteurI * 100 / valeurs.length);
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(2)).limiteInf = valeurs[compteur];
			compteurI = 0;
			while (valeurs[compteur] < (moyenne - (ec / 2))) {
				compteur += 1;
				compteurI += 1;
			}
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(2)).limiteSup = valeurs[compteur];
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(2)).nbreIndividus = compteurI;
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(2)).partIndividus = (compteurI * 100 / valeurs.length);
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(3)).limiteInf = valeurs[compteur];
			compteurI = 0;
			while (valeurs[compteur] < (moyenne + (ec / 2))) {
				compteur += 1;
				compteurI += 1;
			}
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(3)).limiteSup = valeurs[compteur];
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(3)).nbreIndividus = compteurI;
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(3)).partIndividus = (compteurI * 100 / valeurs.length);
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(4)).limiteInf = valeurs[compteur];
			compteurI = 0;
			while (valeurs[compteur] < (moyenne + (ec * 1.5))) {
				compteur += 1;
				compteurI += 1;
			}
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(4)).limiteSup = valeurs[compteur];
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(4)).nbreIndividus = compteurI;
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(4)).partIndividus = (compteurI * 100 / valeurs.length);
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(5)).limiteInf = valeurs[compteur];
			compteurI = 0;
			while (valeurs[compteur] < (moyenne - (ec * 2.5))) {
				compteur += 1;
				compteurI += 1;
			}
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(5)).limiteSup = valeurs[compteur];
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(5)).nbreIndividus = compteurI;
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(5)).partIndividus = (compteurI * 100 / valeurs.length);
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(6)).limiteInf = valeurs[compteur];
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(6)).limiteSup = valeurs[valeurs.length - 1];
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(6)).nbreIndividus = valeurs.length - compteur;
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(6)).partIndividus = ((valeurs.length - compteur) * 100 / valeurs.length);
		}
	}

	private void genereCarte() {
		//Génération nouvelle structure de classe Carte
		int i = 0;
		boolean lvide = true;
		if (tempCarte.analysePlages.typeDiscret == 5) disecManuelle();
		for (i = 0; i < tempCarte.analysePlages.nbreClasses; i++) {
			Integer vide = ((JTextField) getjTFL(i + 1)).getText().length();
			if (vide != 0) {
				((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(i)).titreLeg = getjTFL(i + 1).getText();
				lvide = false;
			}
		}
		if (lvide == true) jBLAuto.doClick();
		this.tempCarte.setTypeAnalyse(1);
		if (jrbcm1.isSelected()) this.tempCarte.setTypeAnalyse(3);
		if (jrbcm2.isSelected()) this.tempCarte.setTypeAnalyse(4);
		if (jrbcm3.isSelected()) this.tempCarte.setTypeAnalyse(1);
		base.carte = (Carte) tempCarte.copie();
		if (base.panneauCentral.fenLegende != null) {
			if (base.carte.getTypeAnalyse() == 1) {
				int hauteur = 60 + (base.carte.analysePlages.nbreClasses * 26);
				base.panneauCentral.fenLegende.reshape(400, 0, 240, hauteur);
			} else {
				base.panneauCentral.fenLegende.reshape(400, 0, 240, 270);
			}
		}
		setVisible(false);
		dispose();
	}

	private javax.swing.JLabel getCaisson(int index) {
		switch (index) {
		case 1:
			return Caisson1;
		case 2:
			return Caisson2;
		case 3:
			return Caisson3;
		case 4:
			return Caisson4;
		case 5:
			return Caisson5;
		case 6:
			return Caisson6;
		case 7:
			return Caisson7;
		case 8:
			return Caisson8;
		}
		return Caisson1;
	}

	private double getEcart(double[] valeurs, int classe, double moyenne) {
		int i = 0;
		double somme = 0;
		int debut = 0;
		for (i = 0; i < classe; i++) {
			debut += ((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(i)).nbreIndividus;
		}
		int bout = debut + ((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(classe)).nbreIndividus;
		//if (classe = ((ClasseDiscret) tempCarte.analysePlages.nbreClasses)
		// bout += 1;
		for (i = debut; i < bout; i++) {
			somme += Math.abs((moyenne - valeurs[i]));
		}
		return (somme / valeurs.length);
	}

	private double getEcType(double[] valeurs) {
		int i = 0;
		double somme = 0;
		double moyenne = getMoyenne(valeurs, 0, valeurs.length);
		for (i = 0; i < valeurs.length; i++) {
			somme += Math.pow((moyenne - valeurs[i]), 2);
		}
		return Math.sqrt((somme / valeurs.length));
	}

	private int getIndice(double[] valeurs, double element) {
		int i = 0;
		for (i = 0; i < valeurs.length; i++) {
			if (valeurs[i] > element) {
				return i;
			}
		}
		return 0;
	}

	private javax.swing.JLabel getjLD(int index) {
		switch (index) {
		case 1:
			return jLD1;
		case 2:
			return jLD2;
		case 3:
			return jLD3;
		case 4:
			return jLD4;
		case 5:
			return jLD5;
		case 6:
			return jLD6;
		case 7:
			return jLD7;
		case 8:
			return jLD8;
		}
		return jLD1;
	}

	private javax.swing.JLabel getjLL(int index) {
		switch (index) {
		case 1:
			return jLL1;
		case 2:
			return jLL2;
		case 3:
			return jLL3;
		case 4:
			return jLL4;
		case 5:
			return jLL5;
		case 6:
			return jLL6;
		case 7:
			return jLL7;
		case 8:
			return jLL8;
		}
		return jLL1;
	}

	private javax.swing.JLabel getjLN(int index) {
		switch (index) {
		case 1:
			return jln1;
		case 2:
			return jln2;
		case 3:
			return jln3;
		case 4:
			return jln4;
		case 5:
			return jln5;
		case 6:
			return jln6;
		case 7:
			return jln7;
		case 8:
			return jln8;
		}
		return jln1;
	}

	private javax.swing.JLabel getjLP(int index) {
		switch (index) {
		case 1:
			return jlp1;
		case 2:
			return jlp2;
		case 3:
			return jlp3;
		case 4:
			return jlp4;
		case 5:
			return jlp5;
		case 6:
			return jlp6;
		case 7:
			return jlp7;
		case 8:
			return jlp8;
		}
		return jlp1;
	}

	private JRadioButton getjRB(int index) {
		switch (index) {
		case 1:
			return jrbc1;
		case 2:
			return jrbc2;
		case 3:
			return jrbc3;
		case 4:
			return jrbc4;
		case 5:
			return jrbc5;
		case 6:
			return jrbc6;
		case 7:
			return jrbc7;
		case 8:
			return jrbc8;
		}
		return jrbc1;
	}

	private javax.swing.JTextField getjTFcmax(int index) {
		switch (index) {
		case 1:
			return jtfc1max;
		case 2:
			return jtfc2max;
		case 3:
			return jtfc3max;
		case 4:
			return jtfc4max;
		case 5:
			return jtfc5max;
		case 6:
			return jtfc6max;
		case 7:
			return jtfc7max;
		case 8:
			return jtfc8max;
		}
		return jtfc1max;
	}

	private javax.swing.JTextField getjTFcmin(int index) {
		switch (index) {
		case 1:
			return jtfc1min;
		case 2:
			return jtfc2min;
		case 3:
			return jtfc3min;
		case 4:
			return jtfc4min;
		case 5:
			return jtfc5min;
		case 6:
			return jtfc6min;
		case 7:
			return jtfc7min;
		case 8:
			return jtfc8min;
		}
		return jtfc1min;
	}

	private javax.swing.JTextField getjTFL(int index) {
		switch (index) {
		case 1:
			return jtfl1;
		case 2:
			return jtfl2;
		case 3:
			return jtfl3;
		case 4:
			return jtfl4;
		case 5:
			return jtfl5;
		case 6:
			return jtfl6;
		case 7:
			return jtfl7;
		case 8:
			return jtfl8;
		}
		return jtfl1;
	}

	private double getMoyenne(double[] valeurs, int debut, int bout) {
		//Calcul de la moyenne de la variable en cours entre deux individus
		// triés
		int i = 0;
		double somme = 0;
		double moyenne = 0;
		for (i = debut; i < bout; i++) {
			somme += valeurs[i];
		}
		moyenne = somme / (bout - debut);
		return moyenne;
	}

	private double[] getValeursTriees() {
		int i = 0;
		int ni = data.size() / colonnes.size();
		double[] valeurs = new double[ni];
		for (i = 0; i < ni; i++) {
			int position = (i * colonnes.size()) + tempCarte.analysePlages.champNum;
			if (data.elementAt(position) == null) {
				valeurs[i] = 0;
				continue;
			}
			switch (((champDonnees) colonnes.get(tempCarte.analysePlages.champNum)).typeI) {
			case 0:
				valeurs[i] = ((Integer) data.elementAt(position)).doubleValue();
				break;
			case 2:
				valeurs[i] = ((Double) data.elementAt(position)).doubleValue();
				break;
			}
		}
		Arrays.sort(valeurs);
		return valeurs;
	}

	private void goDisec() {
		switch (tempCarte.analysePlages.typeDiscret) {
		case 0:
			disecQuantiles();
			majAffichageClasses();
			break;
		case 1:
			disecEquivalences();
			majAffichageClasses();
			break;
		case 2:
			disecMoyennes();
			majAffichageClasses();
			break;
		case 3:
			disecStandard();
			majAffichageClasses();
			break;
		case 4:
			disecNuages();
			majAffichageClasses();
			break;
		case 5:
			disecManuelle();
			majAffichageClasses();
			break;
		}
	}

	/**
	 * This method is called from within the constructor to initialize the form.
	 * WARNING: Do NOT modify this code. The content of this method is always
	 * regenerated by the Form Editor.
	 */
	private void initComponents() {//GEN-BEGIN:initComponents
		buttonGroup1 = new javax.swing.ButtonGroup();
		buttonGroup2 = new javax.swing.ButtonGroup();
		jTabbedPane1 = new javax.swing.JTabbedPane();
		jPanel1 = new javax.swing.JPanel();
		jLabel1 = new javax.swing.JLabel();
		jComboBox1 = new javax.swing.JComboBox();
		jPanel2 = new javax.swing.JPanel();
		jLabel2 = new javax.swing.JLabel();
		jRadioButton1 = new javax.swing.JRadioButton();
		jRadioButton2 = new javax.swing.JRadioButton();
		jRadioButton3 = new javax.swing.JRadioButton();
		jRadioButton4 = new javax.swing.JRadioButton();
		jRadioButton5 = new javax.swing.JRadioButton();
		jRadioButton6 = new javax.swing.JRadioButton();
		jSeparator1 = new javax.swing.JSeparator();
		jLabel3 = new javax.swing.JLabel();
		jSlider1 = new javax.swing.JSlider();
		nbClassesLabel = new javax.swing.JLabel();
		jBGraphique = new javax.swing.JButton();
		jtfc8min = new javax.swing.JTextField();
		jtfc8max = new javax.swing.JTextField();
		jtfc7min = new javax.swing.JTextField();
		jtfc7max = new javax.swing.JTextField();
		jtfc6min = new javax.swing.JTextField();
		jtfc6max = new javax.swing.JTextField();
		jtfc5min = new javax.swing.JTextField();
		jtfc5max = new javax.swing.JTextField();
		jtfc4min = new javax.swing.JTextField();
		jtfc4max = new javax.swing.JTextField();
		jtfc3min = new javax.swing.JTextField();
		jtfc3max = new javax.swing.JTextField();
		jtfc2min = new javax.swing.JTextField();
		jtfc2max = new javax.swing.JTextField();
		jtfc1min = new javax.swing.JTextField();
		jtfc1max = new javax.swing.JTextField();
		jln8 = new javax.swing.JLabel();
		jlp8 = new javax.swing.JLabel();
		jln7 = new javax.swing.JLabel();
		jlp7 = new javax.swing.JLabel();
		jln6 = new javax.swing.JLabel();
		jlp6 = new javax.swing.JLabel();
		jln5 = new javax.swing.JLabel();
		jlp5 = new javax.swing.JLabel();
		jln4 = new javax.swing.JLabel();
		jlp4 = new javax.swing.JLabel();
		jln3 = new javax.swing.JLabel();
		jlp3 = new javax.swing.JLabel();
		jln2 = new javax.swing.JLabel();
		jlp2 = new javax.swing.JLabel();
		jln1 = new javax.swing.JLabel();
		jlp1 = new javax.swing.JLabel();
		jLabel20 = new javax.swing.JLabel();
		jLabel21 = new javax.swing.JLabel();
		jLabel22 = new javax.swing.JLabel();
		jLabel23 = new javax.swing.JLabel();
		jLD8 = new javax.swing.JLabel();
		jLD7 = new javax.swing.JLabel();
		jLD6 = new javax.swing.JLabel();
		jLD5 = new javax.swing.JLabel();
		jLD4 = new javax.swing.JLabel();
		jLD3 = new javax.swing.JLabel();
		jLD2 = new javax.swing.JLabel();
		jLD1 = new javax.swing.JLabel();
		jSeparator2 = new javax.swing.JSeparator();
		jPanel3 = new javax.swing.JPanel();
		jrbc2 = new javax.swing.JRadioButton();
		jrbc3 = new javax.swing.JRadioButton();
		jrbc4 = new javax.swing.JRadioButton();
		jrbc5 = new javax.swing.JRadioButton();
		jrbc6 = new javax.swing.JRadioButton();
		jrbc7 = new javax.swing.JRadioButton();
		jrbc8 = new javax.swing.JRadioButton();
		jrbc1 = new javax.swing.JRadioButton();
		Caisson1 = new javax.swing.JLabel();
		Caisson2 = new javax.swing.JLabel();
		Caisson3 = new javax.swing.JLabel();
		Caisson4 = new javax.swing.JLabel();
		Caisson5 = new javax.swing.JLabel();
		Caisson6 = new javax.swing.JLabel();
		Caisson8 = new javax.swing.JLabel();
		Caisson7 = new javax.swing.JLabel();
		jBDBleu = new javax.swing.JButton();
		jBDVert = new javax.swing.JButton();
		jBDRouge = new javax.swing.JButton();
		jBDGris = new javax.swing.JButton();
		cyanSlider = new javax.swing.JSlider();
		noirSlider = new javax.swing.JSlider();
		jLabel32 = new javax.swing.JLabel();
		magentaSlider = new javax.swing.JSlider();
		jLabel33 = new javax.swing.JLabel();
		jauneSlider = new javax.swing.JSlider();
		jLabel34 = new javax.swing.JLabel();
		cyanLabel = new javax.swing.JLabel();
		magentaLabel = new javax.swing.JLabel();
		jauneLabel = new javax.swing.JLabel();
		noirLabel = new javax.swing.JLabel();
		jLabel35 = new javax.swing.JLabel();
		jBDegrade = new javax.swing.JButton();
		jBInversion = new javax.swing.JButton();
		jPanel4 = new javax.swing.JPanel();
		jSeparator3 = new javax.swing.JSeparator();
		jLabel43 = new javax.swing.JLabel();
		jLabel44 = new javax.swing.JLabel();
		jLabel45 = new javax.swing.JLabel();
		jLabel46 = new javax.swing.JLabel();
		jLabel47 = new javax.swing.JLabel();
		jTextField1 = new javax.swing.JTextField();
		jTextField2 = new javax.swing.JTextField();
		jTextField24 = new javax.swing.JTextField();
		jButton10 = new javax.swing.JButton();
		jButton11 = new javax.swing.JButton();
		jButton12 = new javax.swing.JButton();
		jLabel48 = new javax.swing.JLabel();
		jLabel49 = new javax.swing.JLabel();
		jButton13 = new javax.swing.JButton();
		jTextField25 = new javax.swing.JTextField();
		jTextField26 = new javax.swing.JTextField();
		jButton14 = new javax.swing.JButton();
		jPanel5 = new javax.swing.JPanel();
		jLL8 = new javax.swing.JLabel();
		jLL7 = new javax.swing.JLabel();
		jLL6 = new javax.swing.JLabel();
		jLL5 = new javax.swing.JLabel();
		jLL4 = new javax.swing.JLabel();
		jLL3 = new javax.swing.JLabel();
		jLL2 = new javax.swing.JLabel();
		jLL1 = new javax.swing.JLabel();
		jtfl8 = new javax.swing.JTextField();
		jtfl7 = new javax.swing.JTextField();
		jtfl6 = new javax.swing.JTextField();
		jtfl5 = new javax.swing.JTextField();
		jtfl4 = new javax.swing.JTextField();
		jtfl3 = new javax.swing.JTextField();
		jtfl2 = new javax.swing.JTextField();
		jtfl1 = new javax.swing.JTextField();
		jBLAuto = new javax.swing.JButton();
		jBLFonte = new javax.swing.JButton();
		bgcm = new javax.swing.ButtonGroup();
		jrbcm1 =  new javax.swing.JRadioButton();
		jrbcm2 = new javax.swing.JRadioButton();
		jrbcm3 = new javax.swing.JRadioButton();
		int tac = base.carte.getTypeAnalyse();
		if (tac == 0 || tac == 1) {
			jrbcm1.setEnabled(false);
			jrbcm2.setEnabled(false);
		}
		jBOk = new javax.swing.JButton();
		jBAnnuler = new javax.swing.JButton();

		getContentPane().setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

		setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
		jTabbedPane1.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$

		jPanel1.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

		jLabel1.setFont(new java.awt.Font("Dialog", 0, 12)); //$NON-NLS-1$
		jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		jLabel1.setText(Messages.getString("BoiteDialogueChoroCouleur.2")); //$NON-NLS-1$
		jLabel1.setAlignmentX(20.0F);
		jPanel1.add(jLabel1, new org.netbeans.lib.awtextra.AbsoluteConstraints(70, 100, 50, 20));

		jComboBox1.setFont(new java.awt.Font("Dialog", 0, 12)); //$NON-NLS-1$
		jComboBox1.setToolTipText(Messages.getString("BoiteDialogueChoroCouleur.4")); //$NON-NLS-1$
		//remplissage combo choix champs
		int i = 0;
		int champSelectionne = 0;
		int compteur = 0;
		for (i = 0; i < colonnes.size(); i++) {
			int ti = ((champDonnees) colonnes.get(i)).typeI;
			if (ti == 0 || ti == 2) {
				compteur += 1;
				jComboBox1.addItem(((champDonnees) colonnes.get(i)).nom);
				if (tempCarte.analysePlages.champNum != -1 && i == tempCarte.analysePlages.champNum) {
					champSelectionne = compteur - 1;
				}
			}
		}
		//sélection si carte en cours
		if (tempCarte.analysePlages.champNum != -1) {
			jComboBox1.setSelectedIndex(champSelectionne);
		}
		jComboBox1.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				jComboBox1ActionPerformed(evt);
			}
		});

		jPanel1.add(jComboBox1, new org.netbeans.lib.awtextra.AbsoluteConstraints(130, 100, 197, -1));

		jTabbedPane1.addTab(Messages.getString("BoiteDialogueChoroCouleur.0"), jPanel1); //$NON-NLS-1$

		jPanel2.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

		jLabel2.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jLabel2.setText(Messages.getString("BoiteDialogueChoroCouleur.7")); //$NON-NLS-1$
		jPanel2.add(jLabel2, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 50, -1, -1));

		jRadioButton1.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jRadioButton1.setText(Messages.getString("BoiteDialogueChoroCouleur.9")); //$NON-NLS-1$
		if (tempCarte.analysePlages.champNum != -1 && tempCarte.analysePlages.typeDiscret == 0)
			jRadioButton1.setSelected(true);
		jRadioButton1.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				tempCarte.analysePlages.typeDiscret = 0;
				goDisec();
			}
		});
		buttonGroup1.add(jRadioButton1);
		jPanel2.add(jRadioButton1, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 70, -1, -1));

		jRadioButton2.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jRadioButton2.setText(Messages.getString("BoiteDialogueChoroCouleur.11")); //$NON-NLS-1$
		if (tempCarte.analysePlages.champNum != -1 && tempCarte.analysePlages.typeDiscret == 1)
			jRadioButton2.setSelected(true);
		jRadioButton2.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				tempCarte.analysePlages.typeDiscret = 1;
				goDisec();
			}
		});
		buttonGroup1.add(jRadioButton2);
		jPanel2.add(jRadioButton2, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 90, -1, -1));

		jRadioButton3.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jRadioButton3.setText(Messages.getString("BoiteDialogueChoroCouleur.13")); //$NON-NLS-1$
		if (tempCarte.analysePlages.champNum != -1 && tempCarte.analysePlages.typeDiscret == 2)
			jRadioButton3.setSelected(true);
		jRadioButton3.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				tempCarte.analysePlages.typeDiscret = 2;
				goDisec();
			}
		});
		buttonGroup1.add(jRadioButton3);
		jPanel2.add(jRadioButton3, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 110, -1, -1));

		jRadioButton4.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jRadioButton4.setText(Messages.getString("BoiteDialogueChoroCouleur.15")); //$NON-NLS-1$
		if (tempCarte.analysePlages.champNum != -1 && tempCarte.analysePlages.typeDiscret == 3)
			jRadioButton4.setSelected(true);
		jRadioButton4.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				tempCarte.analysePlages.typeDiscret = 3;
				goDisec();
			}
		});
		buttonGroup1.add(jRadioButton4);
		jPanel2.add(jRadioButton4, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 130, -1, -1));

		jRadioButton5.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jRadioButton5.setText(Messages.getString("BoiteDialogueChoroCouleur.17")); //$NON-NLS-1$
		if (tempCarte.analysePlages.champNum != -1 && tempCarte.analysePlages.typeDiscret == 4)
			jRadioButton5.setSelected(true);
		jRadioButton5.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				tempCarte.analysePlages.typeDiscret = 4;
				goDisec();
			}
		});
		buttonGroup1.add(jRadioButton5);
		jPanel2.add(jRadioButton5, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 150, -1, -1));

		jRadioButton6.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jRadioButton6.setText(Messages.getString("BoiteDialogueChoroCouleur.19")); //$NON-NLS-1$
		if (tempCarte.analysePlages.champNum != -1 && tempCarte.analysePlages.typeDiscret == 5)
			jRadioButton6.setSelected(true);
		jRadioButton6.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				tempCarte.analysePlages.typeDiscret = 5;
				goDisec();
			}
		});
		buttonGroup1.add(jRadioButton6);
		jPanel2.add(jRadioButton6, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 180, -1, -1));

		jSeparator1.setOrientation(javax.swing.SwingConstants.VERTICAL);
		jPanel2.add(jSeparator1, new org.netbeans.lib.awtextra.AbsoluteConstraints(100, 40, 10, 190));

		jLabel3.setFont(new java.awt.Font("Dialog", 0, 12)); //$NON-NLS-1$
		jLabel3.setText(Messages.getString("BoiteDialogueChoroCouleur.21")); //$NON-NLS-1$
		jPanel2.add(jLabel3, new org.netbeans.lib.awtextra.AbsoluteConstraints(60, 10, -1, -1));

		jSlider1.setPaintTicks(true);
		jSlider1.setMajorTickSpacing(1);
		//Positionnement du curseur nombre de classes
		jSlider1.setMinimum(2);
		jSlider1.setMaximum(8);
		if (tempCarte.analysePlages.champNum != -1) {
			jSlider1.setValue(tempCarte.analysePlages.nbreClasses);
		} else {
			jSlider1.setValue(5);
		}
		jSlider1.setSnapToTicks(true);
		jSlider1.addChangeListener(new javax.swing.event.ChangeListener() {
			public void stateChanged(javax.swing.event.ChangeEvent evt) {
				jSlider1StateChanged(evt);
			}
		});

		jPanel2.add(jSlider1, new org.netbeans.lib.awtextra.AbsoluteConstraints(180, 10, 110, -1));

		nbClassesLabel.setFont(new java.awt.Font("Dialog", 0, 12)); //$NON-NLS-1$
		//Positionnement du curseur nombre de classes
		if (tempCarte.analysePlages.champNum != -1) {
			nbClassesLabel.setText(String.valueOf(tempCarte.analysePlages.nbreClasses));
		} else {
			nbClassesLabel.setText(Messages.getString("BoiteDialogueChoroCouleur.23")); //$NON-NLS-1$
		}
		jPanel2.add(nbClassesLabel, new org.netbeans.lib.awtextra.AbsoluteConstraints(290, 10, -1, -1));

		jtfc8min.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jtfc8min.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
		if (tempCarte.analysePlages.champNum != -1 && tempCarte.analysePlages.nbreClasses == 8)
			jtfc8min.setText(String.valueOf(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(7)).limiteInf));
		jtfc8min.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				jtfc8minActionPerformed(evt);
			}
		});

		jPanel2.add(jtfc8min, new org.netbeans.lib.awtextra.AbsoluteConstraints(160, 70, 68, -1));

		jtfc8max.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jtfc8max.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
		if (tempCarte.analysePlages.champNum != -1 && tempCarte.analysePlages.nbreClasses == 8)
			jtfc8max.setText(String.valueOf(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(7)).limiteSup));
		jPanel2.add(jtfc8max, new org.netbeans.lib.awtextra.AbsoluteConstraints(240, 70, 68, -1));

		jtfc7min.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jtfc7min.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
		if (tempCarte.analysePlages.champNum != -1 && tempCarte.analysePlages.nbreClasses >= 7)
			jtfc7min.setText(String.valueOf(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(6)).limiteInf));
		jPanel2.add(jtfc7min, new org.netbeans.lib.awtextra.AbsoluteConstraints(160, 90, 68, -1));

		jtfc7max.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jtfc7max.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
		if (tempCarte.analysePlages.champNum != -1 && tempCarte.analysePlages.nbreClasses >= 7)
			jtfc7max.setText(String.valueOf(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(6)).limiteSup));
		jPanel2.add(jtfc7max, new org.netbeans.lib.awtextra.AbsoluteConstraints(240, 90, 68, -1));

		jtfc6min.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jtfc6min.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
		if (tempCarte.analysePlages.champNum != -1 && tempCarte.analysePlages.nbreClasses >= 6)
			jtfc6min.setText(String.valueOf(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(5)).limiteInf));
		jPanel2.add(jtfc6min, new org.netbeans.lib.awtextra.AbsoluteConstraints(160, 110, 68, -1));

		jtfc6max.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jtfc6max.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
		if (tempCarte.analysePlages.champNum != -1 && tempCarte.analysePlages.nbreClasses >= 6)
			jtfc6max.setText(String.valueOf(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(5)).limiteSup));
		jPanel2.add(jtfc6max, new org.netbeans.lib.awtextra.AbsoluteConstraints(240, 110, 68, -1));

		jtfc5min.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jtfc5min.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
		if (tempCarte.analysePlages.champNum != -1 && tempCarte.analysePlages.nbreClasses >= 5)
			jtfc5min.setText(String.valueOf(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(4)).limiteInf));
		jPanel2.add(jtfc5min, new org.netbeans.lib.awtextra.AbsoluteConstraints(160, 130, 68, -1));

		jtfc5max.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jtfc5max.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
		if (tempCarte.analysePlages.champNum != -1 && tempCarte.analysePlages.nbreClasses >= 5)
			jtfc5max.setText(String.valueOf(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(4)).limiteSup));
		jPanel2.add(jtfc5max, new org.netbeans.lib.awtextra.AbsoluteConstraints(240, 130, 68, -1));

		jtfc4min.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jtfc4min.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
		if (tempCarte.analysePlages.champNum != -1 && tempCarte.analysePlages.nbreClasses >= 4)
			jtfc4min.setText(String.valueOf(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(3)).limiteInf));
		jPanel2.add(jtfc4min, new org.netbeans.lib.awtextra.AbsoluteConstraints(160, 150, 68, -1));

		jtfc4max.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jtfc4max.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
		if (tempCarte.analysePlages.champNum != -1 && tempCarte.analysePlages.nbreClasses >= 4)
			jtfc4max.setText(String.valueOf(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(3)).limiteSup));
		jPanel2.add(jtfc4max, new org.netbeans.lib.awtextra.AbsoluteConstraints(240, 150, 68, 20));

		jtfc3min.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jtfc3min.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
		if (tempCarte.analysePlages.champNum != -1 && tempCarte.analysePlages.nbreClasses >= 3)
			jtfc3min.setText(String.valueOf(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(2)).limiteInf));
		jPanel2.add(jtfc3min, new org.netbeans.lib.awtextra.AbsoluteConstraints(160, 170, 68, -1));

		jtfc3max.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jtfc3max.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
		if (tempCarte.analysePlages.champNum != -1 && tempCarte.analysePlages.nbreClasses >= 3)
			jtfc3max.setText(String.valueOf(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(2)).limiteSup));
		jPanel2.add(jtfc3max, new org.netbeans.lib.awtextra.AbsoluteConstraints(240, 170, 68, -1));

		jtfc2min.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jtfc2min.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
		if (tempCarte.analysePlages.champNum != -1 && tempCarte.analysePlages.nbreClasses >= 2)
			jtfc2min.setText(String.valueOf(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(1)).limiteInf));
		jPanel2.add(jtfc2min, new org.netbeans.lib.awtextra.AbsoluteConstraints(160, 190, 68, -1));

		jtfc2max.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jtfc2max.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
		if (tempCarte.analysePlages.champNum != -1 && tempCarte.analysePlages.nbreClasses >= 2)
			jtfc2max.setText(String.valueOf(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(1)).limiteSup));
		jPanel2.add(jtfc2max, new org.netbeans.lib.awtextra.AbsoluteConstraints(240, 190, 68, -1));

		jtfc1min.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jtfc1min.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
		if (tempCarte.analysePlages.champNum != -1 && tempCarte.analysePlages.nbreClasses >= 1)
			jtfc1min.setText(String.valueOf(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(0)).limiteInf));
		jtfc1min.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				jTextField15ActionPerformed(evt);
			}
		});

		jPanel2.add(jtfc1min, new org.netbeans.lib.awtextra.AbsoluteConstraints(160, 210, 68, -1));

		jtfc1max.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jtfc1max.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
		if (tempCarte.analysePlages.champNum != -1 && tempCarte.analysePlages.nbreClasses >= 1)
			jtfc1max.setText(String.valueOf(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(0)).limiteSup));
		jPanel2.add(jtfc1max, new org.netbeans.lib.awtextra.AbsoluteConstraints(240, 210, 68, -1));

		jln8.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		if (tempCarte.analysePlages.champNum != -1 && tempCarte.analysePlages.nbreClasses == 8)
			jln8.setText(String.valueOf(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(7)).nbreIndividus));
		jPanel2.add(jln8, new org.netbeans.lib.awtextra.AbsoluteConstraints(320, 70, 26, 24));

		jlp8.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		if (tempCarte.analysePlages.champNum != -1 && tempCarte.analysePlages.nbreClasses == 8)
			jlp8.setText(String.valueOf(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(7)).partIndividus));
		jPanel2.add(jlp8, new org.netbeans.lib.awtextra.AbsoluteConstraints(350, 70, 26, 24));

		jln7.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		if (tempCarte.analysePlages.champNum != -1 && tempCarte.analysePlages.nbreClasses >= 7)
			jln7.setText(String.valueOf(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(6)).nbreIndividus));
		jPanel2.add(jln7, new org.netbeans.lib.awtextra.AbsoluteConstraints(320, 90, 26, 24));

		jlp7.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		if (tempCarte.analysePlages.champNum != -1 && tempCarte.analysePlages.nbreClasses >= 7)
			jlp7.setText(String.valueOf(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(6)).partIndividus));
		jPanel2.add(jlp7, new org.netbeans.lib.awtextra.AbsoluteConstraints(350, 90, 26, 24));

		jln6.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		if (tempCarte.analysePlages.champNum != -1 && tempCarte.analysePlages.nbreClasses >= 6)
			jln6.setText(String.valueOf(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(5)).nbreIndividus));
		jPanel2.add(jln6, new org.netbeans.lib.awtextra.AbsoluteConstraints(320, 110, 26, 24));

		jlp6.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		if (tempCarte.analysePlages.champNum != -1 && tempCarte.analysePlages.nbreClasses >= 6)
			jlp6.setText(String.valueOf(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(5)).partIndividus));
		jPanel2.add(jlp6, new org.netbeans.lib.awtextra.AbsoluteConstraints(350, 110, 26, 24));

		jln5.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		if (tempCarte.analysePlages.champNum != -1 && tempCarte.analysePlages.nbreClasses >= 5)
			jln5.setText(String.valueOf(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(4)).nbreIndividus));
		jPanel2.add(jln5, new org.netbeans.lib.awtextra.AbsoluteConstraints(320, 130, 26, 24));

		jlp5.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		if (tempCarte.analysePlages.champNum != -1 && tempCarte.analysePlages.nbreClasses >= 5)
			jlp5.setText(String.valueOf(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(4)).partIndividus));
		jPanel2.add(jlp5, new org.netbeans.lib.awtextra.AbsoluteConstraints(350, 130, 26, 24));

		jln4.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		if (tempCarte.analysePlages.champNum != -1 && tempCarte.analysePlages.nbreClasses >= 4)
			jln4.setText(String.valueOf(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(3)).nbreIndividus));
		jPanel2.add(jln4, new org.netbeans.lib.awtextra.AbsoluteConstraints(320, 150, 26, 24));

		jlp4.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		if (tempCarte.analysePlages.champNum != -1 && tempCarte.analysePlages.nbreClasses >= 4)
			jlp4.setText(String.valueOf(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(3)).partIndividus));
		jPanel2.add(jlp4, new org.netbeans.lib.awtextra.AbsoluteConstraints(350, 150, 26, 24));

		jln3.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		if (tempCarte.analysePlages.champNum != -1 && tempCarte.analysePlages.nbreClasses >= 3)
			jln3.setText(String.valueOf(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(2)).nbreIndividus));
		jPanel2.add(jln3, new org.netbeans.lib.awtextra.AbsoluteConstraints(320, 170, 26, 24));

		jlp3.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		if (tempCarte.analysePlages.champNum != -1 && tempCarte.analysePlages.nbreClasses >= 3)
			jlp3.setText(String.valueOf(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(2)).partIndividus));
		jPanel2.add(jlp3, new org.netbeans.lib.awtextra.AbsoluteConstraints(350, 170, 26, 24));

		jln2.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		if (tempCarte.analysePlages.champNum != -1 && tempCarte.analysePlages.nbreClasses >= 2)
			jln2.setText(String.valueOf(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(1)).nbreIndividus));
		jPanel2.add(jln2, new org.netbeans.lib.awtextra.AbsoluteConstraints(320, 190, 26, 24));

		jlp2.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		if (tempCarte.analysePlages.champNum != -1 && tempCarte.analysePlages.nbreClasses >= 2)
			jlp2.setText(String.valueOf(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(1)).partIndividus));
		jPanel2.add(jlp2, new org.netbeans.lib.awtextra.AbsoluteConstraints(350, 190, 26, 24));

		jln1.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		if (tempCarte.analysePlages.champNum != -1 && tempCarte.analysePlages.nbreClasses >= 1)
			jln1.setText(String.valueOf(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(0)).nbreIndividus));
		jPanel2.add(jln1, new org.netbeans.lib.awtextra.AbsoluteConstraints(320, 210, 26, 24));

		jlp1.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		if (tempCarte.analysePlages.champNum != -1 && tempCarte.analysePlages.nbreClasses >= 1)
			jlp1.setText(String.valueOf(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(0)).partIndividus));
		jPanel2.add(jlp1, new org.netbeans.lib.awtextra.AbsoluteConstraints(350, 210, 26, 24));

		jLabel20.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jLabel20.setText(Messages.getString("BoiteDialogueChoroCouleur.57")); //$NON-NLS-1$
		jPanel2.add(jLabel20, new org.netbeans.lib.awtextra.AbsoluteConstraints(160, 50, -1, -1));

		jLabel21.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jLabel21.setText(Messages.getString("BoiteDialogueChoroCouleur.59")); //$NON-NLS-1$
		jPanel2.add(jLabel21, new org.netbeans.lib.awtextra.AbsoluteConstraints(260, 50, -1, -1));

		jLabel22.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jLabel22.setText(Messages.getString("BoiteDialogueChoroCouleur.61")); //$NON-NLS-1$
		jPanel2.add(jLabel22, new org.netbeans.lib.awtextra.AbsoluteConstraints(320, 50, -1, -1));

		jLabel23.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jLabel23.setText(Messages.getString("BoiteDialogueChoroCouleur.63")); //$NON-NLS-1$
		jPanel2.add(jLabel23, new org.netbeans.lib.awtextra.AbsoluteConstraints(350, 50, -1, -1));

		jLD8.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jLD8.setText(Messages.getString("BoiteDialogueChoroCouleur.65")); //$NON-NLS-1$
		jPanel2.add(jLD8, new org.netbeans.lib.awtextra.AbsoluteConstraints(110, 70, -1, -1));

		jLD7.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jLD7.setText(Messages.getString("BoiteDialogueChoroCouleur.67")); //$NON-NLS-1$
		jPanel2.add(jLD7, new org.netbeans.lib.awtextra.AbsoluteConstraints(110, 90, -1, -1));

		jLD6.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jLD6.setText(Messages.getString("BoiteDialogueChoroCouleur.69")); //$NON-NLS-1$
		jPanel2.add(jLD6, new org.netbeans.lib.awtextra.AbsoluteConstraints(110, 110, -1, -1));

		jLD5.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jLD5.setText(Messages.getString("BoiteDialogueChoroCouleur.71")); //$NON-NLS-1$
		jPanel2.add(jLD5, new org.netbeans.lib.awtextra.AbsoluteConstraints(110, 130, -1, -1));

		jLD4.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jLD4.setText(Messages.getString("BoiteDialogueChoroCouleur.73")); //$NON-NLS-1$
		jPanel2.add(jLD4, new org.netbeans.lib.awtextra.AbsoluteConstraints(110, 150, -1, -1));

		jLD3.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jLD3.setText(Messages.getString("BoiteDialogueChoroCouleur.75")); //$NON-NLS-1$
		jPanel2.add(jLD3, new org.netbeans.lib.awtextra.AbsoluteConstraints(110, 170, -1, -1));

		jLD2.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jLD2.setText(Messages.getString("BoiteDialogueChoroCouleur.77")); //$NON-NLS-1$
		jPanel2.add(jLD2, new org.netbeans.lib.awtextra.AbsoluteConstraints(110, 190, -1, -1));

		jLD1.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jLD1.setText(Messages.getString("BoiteDialogueChoroCouleur.79")); //$NON-NLS-1$
		jPanel2.add(jLD1, new org.netbeans.lib.awtextra.AbsoluteConstraints(110, 210, -1, -1));

		jPanel2.add(jSeparator2, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 40, 90, 10));

		jBGraphique.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jBGraphique.setText(Messages.getString("BoiteDialogueChoroCouleur.81")); //$NON-NLS-1$
		jBGraphique.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				jBGraphiqueActionPerformed(evt);
			}
		});
		jPanel2.add(jBGraphique, new org.netbeans.lib.awtextra.AbsoluteConstraints(12, 210, -1, -1));

		jTabbedPane1.addTab(Messages.getString("BoiteDialogueChoroCouleur.1"), jPanel2); //$NON-NLS-1$

		jPanel3.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

		buttonGroup2.add(jrbc2);
		jrbc2.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				jrbc2MouseClicked(evt);
			}
		});

		jPanel3.add(jrbc2, new org.netbeans.lib.awtextra.AbsoluteConstraints(290, 140, 20, -1));

		buttonGroup2.add(jrbc3);
		jrbc3.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				jrbc3MouseClicked(evt);
			}
		});

		jPanel3.add(jrbc3, new org.netbeans.lib.awtextra.AbsoluteConstraints(290, 120, 20, -1));

		buttonGroup2.add(jrbc4);
		jrbc4.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				jrbc4MouseClicked(evt);
			}
		});

		jPanel3.add(jrbc4, new org.netbeans.lib.awtextra.AbsoluteConstraints(290, 100, 20, -1));

		buttonGroup2.add(jrbc5);
		jrbc5.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				jrbc5MouseClicked(evt);
			}
		});

		jPanel3.add(jrbc5, new org.netbeans.lib.awtextra.AbsoluteConstraints(290, 80, 20, -1));

		buttonGroup2.add(jrbc6);
		jrbc6.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				jrbc6MouseClicked(evt);
			}
		});

		jPanel3.add(jrbc6, new org.netbeans.lib.awtextra.AbsoluteConstraints(290, 60, 20, -1));

		buttonGroup2.add(jrbc7);
		jrbc7.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				jrbc7MouseClicked(evt);
			}
		});

		jPanel3.add(jrbc7, new org.netbeans.lib.awtextra.AbsoluteConstraints(290, 40, 20, -1));

		buttonGroup2.add(jrbc8);
		jrbc8.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				jrbc8MouseClicked(evt);
			}
		});

		jPanel3.add(jrbc8, new org.netbeans.lib.awtextra.AbsoluteConstraints(290, 20, 20, -1));

		jrbc1.setSelected(true);
		buttonGroup2.add(jrbc1);
		jrbc1.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				jrbc1MouseClicked(evt);
			}
		});

		jPanel3.add(jrbc1, new org.netbeans.lib.awtextra.AbsoluteConstraints(290, 160, 20, -1));

		Caisson1.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0)));
		Caisson1.setOpaque(true);
		if (tempCarte.analysePlages.champNum != -1 && tempCarte.analysePlages.nbreClasses >= 1)
			Caisson1.setBackground(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(0)).couleur);
		Caisson1.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				Caisson1MouseClicked(evt);
			}
		});

		jPanel3.add(Caisson1, new org.netbeans.lib.awtextra.AbsoluteConstraints(310, 160, 70, 21));

		Caisson2.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0)));
		Caisson2.setOpaque(true);
		if (tempCarte.analysePlages.champNum != -1 && tempCarte.analysePlages.nbreClasses >= 2)
			Caisson2.setBackground(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(1)).couleur);
		Caisson2.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				Caisson2MouseClicked(evt);
			}
		});

		jPanel3.add(Caisson2, new org.netbeans.lib.awtextra.AbsoluteConstraints(310, 140, 70, 21));

		Caisson3.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0)));
		Caisson3.setOpaque(true);
		if (tempCarte.analysePlages.champNum != -1 && tempCarte.analysePlages.nbreClasses >= 3)
			Caisson3.setBackground(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(2)).couleur);
		Caisson3.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				Caisson3MouseClicked(evt);
			}
		});

		jPanel3.add(Caisson3, new org.netbeans.lib.awtextra.AbsoluteConstraints(310, 120, 70, 21));

		Caisson4.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0)));
		Caisson4.setOpaque(true);
		if (tempCarte.analysePlages.champNum != -1 && tempCarte.analysePlages.nbreClasses >= 4)
			Caisson4.setBackground(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(3)).couleur);
		Caisson4.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				Caisson4MouseClicked(evt);
			}
		});

		jPanel3.add(Caisson4, new org.netbeans.lib.awtextra.AbsoluteConstraints(310, 100, 70, 21));

		Caisson5.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0)));
		Caisson5.setOpaque(true);
		if (tempCarte.analysePlages.champNum != -1 && tempCarte.analysePlages.nbreClasses >= 5)
			Caisson5.setBackground(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(4)).couleur);
		Caisson5.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				Caisson5MouseClicked(evt);
			}
		});

		jPanel3.add(Caisson5, new org.netbeans.lib.awtextra.AbsoluteConstraints(310, 80, 70, 21));

		Caisson6.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0)));
		Caisson6.setOpaque(true);
		if (tempCarte.analysePlages.champNum != -1 && tempCarte.analysePlages.nbreClasses >= 6)
			Caisson6.setBackground(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(5)).couleur);
		Caisson6.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				Caisson6MouseClicked(evt);
			}
		});

		jPanel3.add(Caisson6, new org.netbeans.lib.awtextra.AbsoluteConstraints(310, 60, 70, 21));

		Caisson7.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0)));
		Caisson7.setOpaque(true);
		if (tempCarte.analysePlages.champNum != -1 && tempCarte.analysePlages.nbreClasses >= 7)
			Caisson7.setBackground(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(6)).couleur);
		Caisson7.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				Caisson7MouseClicked(evt);
			}
		});

		jPanel3.add(Caisson7, new org.netbeans.lib.awtextra.AbsoluteConstraints(310, 40, 70, 21));

		Caisson8.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0)));
		Caisson8.setOpaque(true);
		if (tempCarte.analysePlages.champNum != -1 && tempCarte.analysePlages.nbreClasses == 8)
			Caisson8.setBackground(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(7)).couleur);
		Caisson8.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				Caisson8MouseClicked(evt);
			}
		});

		jPanel3.add(Caisson8, new org.netbeans.lib.awtextra.AbsoluteConstraints(310, 20, 70, 21));

		jBDBleu.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jBDBleu.setText(Messages.getString("BoiteDialogueChoroCouleur.84")); //$NON-NLS-1$
		jBDBleu.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				jBDBleuActionPerformed(evt);
			}
		});
		jPanel3.add(jBDBleu, new org.netbeans.lib.awtextra.AbsoluteConstraints(180, 110, 100, -1));

		jBDVert.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jBDVert.setText(Messages.getString("BoiteDialogueChoroCouleur.86")); //$NON-NLS-1$
		jBDVert.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				jBDVertActionPerformed(evt);
			}
		});
		jPanel3.add(jBDVert, new org.netbeans.lib.awtextra.AbsoluteConstraints(180, 140, 100, -1));

		jBDRouge.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jBDRouge.setText(Messages.getString("BoiteDialogueChoroCouleur.88")); //$NON-NLS-1$
		jBDRouge.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				jBDRougeActionPerformed(evt);
			}
		});
		jPanel3.add(jBDRouge, new org.netbeans.lib.awtextra.AbsoluteConstraints(180, 170, 100, -1));

		jBDGris.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jBDGris.setText(Messages.getString("BoiteDialogueChoroCouleur.90")); //$NON-NLS-1$
		jBDGris.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				jBDGrisActionPerformed(evt);
			}
		});
		jPanel3.add(jBDGris, new org.netbeans.lib.awtextra.AbsoluteConstraints(180, 200, 100, -1));

		cyanSlider.setMinorTickSpacing(10);
		cyanSlider.setMaximum(255);
		if (tempCarte.analysePlages.champNum != -1) {
			cyanSlider.setValue(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(0)).couleur.getRed());
			cyanLabel.setText(form.format((double)cyanSlider.getValue() / 255));
		} else {
			cyanSlider.setValue(0);
			cyanLabel.setText(Messages.getString("BoiteDialogueChoroCouleur.91")); //$NON-NLS-1$
		}
		cyanSlider.addChangeListener(new javax.swing.event.ChangeListener() {
			public void stateChanged(javax.swing.event.ChangeEvent evt) {
				cyanSliderStateChanged(evt);
			}
		});

		jPanel3.add(cyanSlider, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 15, 130, -1));

		jLabel32.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jLabel32.setText(Messages.getString("BoiteDialogueChoroCouleur.93")); //$NON-NLS-1$
		jPanel3.add(jLabel32, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 20, -1, -1));

		magentaSlider.setMinorTickSpacing(10);
		magentaSlider.setMaximum(255);
		if (tempCarte.analysePlages.champNum != -1) {
			magentaSlider.setValue(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(0)).couleur.getGreen());
			magentaLabel.setText(form.format((double)magentaSlider.getValue()));
		} else {
			magentaSlider.setValue(0);
			magentaLabel.setText(Messages.getString("BoiteDialogueChoroCouleur.94")); //$NON-NLS-1$
		}
		magentaSlider.addChangeListener(new javax.swing.event.ChangeListener() {
			public void stateChanged(javax.swing.event.ChangeEvent evt) {
				magentaSliderStateChanged(evt);
			}
		});

		jPanel3.add(magentaSlider, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 40, 130, -1));

		jLabel33.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jLabel33.setText(Messages.getString("BoiteDialogueChoroCouleur.96")); //$NON-NLS-1$
		jPanel3.add(jLabel33, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 45, -1, -1));

		jauneSlider.setMinorTickSpacing(10);
		jauneSlider.setMaximum(255);
		if (tempCarte.analysePlages.champNum != -1) {
			jauneSlider.setValue(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(0)).couleur.getBlue());
			jauneLabel.setText(form.format((double)jauneSlider.getValue() / 255));
		} else {
			jauneSlider.setValue(0);
			jauneLabel.setText(Messages.getString("BoiteDialogueChoroCouleur.97")); //$NON-NLS-1$
		}
		jauneSlider.addChangeListener(new javax.swing.event.ChangeListener() {
			public void stateChanged(javax.swing.event.ChangeEvent evt) {
				jauneSliderStateChanged(evt);
			}
		});

		jPanel3.add(jauneSlider, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 65, 130, -1));

		jLabel34.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jLabel34.setText(Messages.getString("BoiteDialogueChoroCouleur.99")); //$NON-NLS-1$
		jPanel3.add(jLabel34, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 70, -1, -1));

		noirSlider.setMinorTickSpacing(10);
		noirSlider.setMaximum(255);
		if (tempCarte.analysePlages.champNum != -1) {
			noirSlider.setValue(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(0)).couleur.getGreen());
			noirLabel.setText(form.format((double)noirSlider.getValue() / 255));
		} else {
			noirSlider.setValue(0);
			noirLabel.setText(Messages.getString("BoiteDialogueChoroCouleur.94")); //$NON-NLS-1$
		}
		noirSlider.addChangeListener(new javax.swing.event.ChangeListener() {
			public void stateChanged(javax.swing.event.ChangeEvent evt) {
				noirSliderStateChanged(evt);
			}
		});

		jPanel3.add(noirSlider, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 90, 130, -1));

		jLabel35.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jLabel35.setText(Messages.getString("BoiteDialogueChoroCouleur.101")); //$NON-NLS-1$
		jPanel3.add(jLabel35, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 95, -1, -1));

		cyanLabel.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jPanel3.add(cyanLabel, new org.netbeans.lib.awtextra.AbsoluteConstraints(150, 20, 30, -1));

		magentaLabel.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jPanel3.add(magentaLabel, new org.netbeans.lib.awtextra.AbsoluteConstraints(150, 45, 30, -1));

		jauneLabel.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jPanel3.add(jauneLabel, new org.netbeans.lib.awtextra.AbsoluteConstraints(150, 70, 30, -1));

		noirLabel.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jPanel3.add(noirLabel, new org.netbeans.lib.awtextra.AbsoluteConstraints(150, 95, 30, -1));

		jBDegrade.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jBDegrade.setText(Messages.getString("BoiteDialogueChoroCouleur.104")); //$NON-NLS-1$
		jBDegrade.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				jBDegradeActionPerformed(evt);
			}
		});
		jPanel3.add(jBDegrade, new org.netbeans.lib.awtextra.AbsoluteConstraints(180, 20, 100, -1));

		jBInversion.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jBInversion.setText(Messages.getString("BoiteDialogueChoroCouleur.106")); //$NON-NLS-1$
		jBInversion.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				jBInversionActionPerformed(evt);
			}
		});
		jPanel3.add(jBInversion, new org.netbeans.lib.awtextra.AbsoluteConstraints(180, 50, 100, -1));

		jTabbedPane1.addTab(Messages.getString("BoiteDialogueChoroCouleur.107"), jPanel3); //$NON-NLS-1$

		/*
		 * jPanel4.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());
		 * 
		 * jPanel4.add(jSeparator3, new
		 * org.netbeans.lib.awtextra.AbsoluteConstraints(0, 130, 390, -1));
		 * 
		 * jLabel43.setFont(new java.awt.Font("Dialog", 0, 10));
		 * jLabel43.setText("Carte :"); jPanel4.add(jLabel43, new
		 * org.netbeans.lib.awtextra.AbsoluteConstraints(10, 10, -1, -1));
		 * 
		 * jLabel44.setFont(new java.awt.Font("Dialog", 0, 10));
		 * jLabel44.setText("L\u00e9gende :"); jPanel4.add(jLabel44, new
		 * org.netbeans.lib.awtextra.AbsoluteConstraints(10, 140, -1, -1));
		 * 
		 * jLabel45.setFont(new java.awt.Font("Dialog", 0, 10));
		 * jLabel45.setText("Titre"); jPanel4.add(jLabel45, new
		 * org.netbeans.lib.awtextra.AbsoluteConstraints(20, 40, -1, -1));
		 * 
		 * jLabel46.setFont(new java.awt.Font("Dialog", 0, 10));
		 * jLabel46.setText("Sous-titre"); jPanel4.add(jLabel46, new
		 * org.netbeans.lib.awtextra.AbsoluteConstraints(20, 70, -1, -1));
		 * 
		 * jLabel47.setFont(new java.awt.Font("Dialog", 0, 10));
		 * jLabel47.setText("Date / Source"); jPanel4.add(jLabel47, new
		 * org.netbeans.lib.awtextra.AbsoluteConstraints(20, 100, -1, -1));
		 * 
		 * jTextField1.setFont(new java.awt.Font("Dialog", 0, 10));
		 * jTextField1.addActionListener(new java.awt.event.ActionListener() {
		 * public void actionPerformed(java.awt.event.ActionEvent evt) {
		 * jTextField1ActionPerformed(evt); } });
		 * 
		 * jPanel4.add(jTextField1, new
		 * org.netbeans.lib.awtextra.AbsoluteConstraints(60, 40, 270, -1));
		 * 
		 * jTextField2.setFont(new java.awt.Font("Dialog", 0, 10));
		 * jPanel4.add(jTextField2, new
		 * org.netbeans.lib.awtextra.AbsoluteConstraints(80, 70, 250, -1));
		 * 
		 * jTextField24.setFont(new java.awt.Font("Dialog", 0, 10));
		 * jPanel4.add(jTextField24, new
		 * org.netbeans.lib.awtextra.AbsoluteConstraints(100, 100, 230, -1));
		 * 
		 * jButton10.setFont(new java.awt.Font("Dialog", 2, 10));
		 * jButton10.setText("Fonte"); jButton10.setMargin(new
		 * java.awt.Insets(2, 2, 2, 2)); jPanel4.add(jButton10, new
		 * org.netbeans.lib.awtextra.AbsoluteConstraints(340, 40, 50, 18));
		 * 
		 * jButton11.setFont(new java.awt.Font("Dialog", 2, 10));
		 * jButton11.setText("Fonte"); jButton11.setMargin(new
		 * java.awt.Insets(2, 2, 2, 2)); jPanel4.add(jButton11, new
		 * org.netbeans.lib.awtextra.AbsoluteConstraints(340, 70, 50, 18));
		 * 
		 * jButton12.setFont(new java.awt.Font("Dialog", 2, 10));
		 * jButton12.setText("Fonte"); jButton12.setMargin(new
		 * java.awt.Insets(2, 2, 2, 2)); jPanel4.add(jButton12, new
		 * org.netbeans.lib.awtextra.AbsoluteConstraints(340, 200, 50, 18));
		 * 
		 * jLabel48.setFont(new java.awt.Font("Dialog", 0, 10));
		 * jLabel48.setText("Titre"); jPanel4.add(jLabel48, new
		 * org.netbeans.lib.awtextra.AbsoluteConstraints(20, 170, -1, -1));
		 * 
		 * jLabel49.setFont(new java.awt.Font("Dialog", 0, 10));
		 * jLabel49.setText("Sous-titre"); jPanel4.add(jLabel49, new
		 * org.netbeans.lib.awtextra.AbsoluteConstraints(20, 200, -1, -1));
		 * 
		 * jButton13.setFont(new java.awt.Font("Dialog", 2, 10));
		 * jButton13.setText("Fonte"); jButton13.setMargin(new
		 * java.awt.Insets(2, 2, 2, 2)); jPanel4.add(jButton13, new
		 * org.netbeans.lib.awtextra.AbsoluteConstraints(340, 170, 50, 18));
		 * 
		 * jTextField25.setFont(new java.awt.Font("Dialog", 0, 10));
		 * jPanel4.add(jTextField25, new
		 * org.netbeans.lib.awtextra.AbsoluteConstraints(80, 200, 250, -1));
		 * 
		 * jTextField26.setFont(new java.awt.Font("Dialog", 0, 10));
		 * jPanel4.add(jTextField26, new
		 * org.netbeans.lib.awtextra.AbsoluteConstraints(60, 170, 270, -1));
		 * 
		 * jButton14.setFont(new java.awt.Font("Dialog", 2, 10));
		 * jButton14.setText("Fonte"); jButton14.setMargin(new
		 * java.awt.Insets(2, 2, 2, 2)); jPanel4.add(jButton14, new
		 * org.netbeans.lib.awtextra.AbsoluteConstraints(340, 100, 50, 18));
		 * 
		 * jTabbedPane1.addTab("Habillage", jPanel4);
		 */

		jPanel5.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

		jLL8.setFont(new java.awt.Font(Messages.getString("BoiteDialogueChoroCouleur.3"), 0, 10)); //$NON-NLS-1$
		jLL8.setText(Messages.getString("BoiteDialogueChoroCouleur.109")); //$NON-NLS-1$
		jPanel5.add(jLL8, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 20, -1, -1));

		jLL7.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jLL7.setText(Messages.getString("BoiteDialogueChoroCouleur.111")); //$NON-NLS-1$
		jPanel5.add(jLL7, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 40, -1, -1));

		jLL6.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jLL6.setText(Messages.getString("BoiteDialogueChoroCouleur.113")); //$NON-NLS-1$
		jPanel5.add(jLL6, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 60, -1, -1));

		jLL5.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jLL5.setText(Messages.getString("BoiteDialogueChoroCouleur.115")); //$NON-NLS-1$
		jPanel5.add(jLL5, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 80, -1, -1));

		jLL4.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jLL4.setText(Messages.getString("BoiteDialogueChoroCouleur.117")); //$NON-NLS-1$
		jPanel5.add(jLL4, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 100, -1, -1));

		jLL3.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jLL3.setText(Messages.getString("BoiteDialogueChoroCouleur.119")); //$NON-NLS-1$
		jPanel5.add(jLL3, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 120, -1, -1));

		jLL2.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jLL2.setText(Messages.getString("BoiteDialogueChoroCouleur.121")); //$NON-NLS-1$
		jPanel5.add(jLL2, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 140, -1, -1));

		jLL1.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jLL1.setText(Messages.getString("BoiteDialogueChoroCouleur.123")); //$NON-NLS-1$
		jPanel5.add(jLL1, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 160, -1, -1));

		jtfl8.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jPanel5.add(jtfl8, new org.netbeans.lib.awtextra.AbsoluteConstraints(70, 20, 230, -1));
		if (tempCarte.analysePlages.nbreClasses == 8) jtfl8.setText(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(7)).titreLeg);
		
		jtfl7.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jPanel5.add(jtfl7, new org.netbeans.lib.awtextra.AbsoluteConstraints(70, 40, 230, -1));
		if (tempCarte.analysePlages.nbreClasses >= 7) jtfl7.setText(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(6)).titreLeg);


		jtfl6.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jPanel5.add(jtfl6, new org.netbeans.lib.awtextra.AbsoluteConstraints(70, 60, 230, -1));
		if (tempCarte.analysePlages.nbreClasses >= 6) jtfl6.setText(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(5)).titreLeg);

		jtfl5.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jPanel5.add(jtfl5, new org.netbeans.lib.awtextra.AbsoluteConstraints(70, 80, 230, -1));
		if (tempCarte.analysePlages.nbreClasses >= 5) jtfl5.setText(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(4)).titreLeg);

		jtfl4.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jPanel5.add(jtfl4, new org.netbeans.lib.awtextra.AbsoluteConstraints(70, 100, 230, -1));
		if (tempCarte.analysePlages.nbreClasses >= 4) jtfl4.setText(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(3)).titreLeg);

		jtfl3.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jPanel5.add(jtfl3, new org.netbeans.lib.awtextra.AbsoluteConstraints(70, 120, 230, -1));
		if (tempCarte.analysePlages.nbreClasses >= 3) jtfl3.setText(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(2)).titreLeg);
		
		jtfl2.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jPanel5.add(jtfl2, new org.netbeans.lib.awtextra.AbsoluteConstraints(70, 140, 230, -1));
		if (tempCarte.analysePlages.nbreClasses >= 2) jtfl2.setText(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(1)).titreLeg);

		jtfl1.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jPanel5.add(jtfl1, new org.netbeans.lib.awtextra.AbsoluteConstraints(70, 160, 230, -1));
		if (tempCarte.analysePlages.nbreClasses >= 1) jtfl1.setText(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(0)).titreLeg);	

		jBLAuto.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jBLAuto.setText(Messages.getString("BoiteDialogueChoroCouleur.133")); //$NON-NLS-1$
		jBLAuto.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				jBLAutoActionPerformed(evt);
			}
		});
		jPanel5.add(jBLAuto, new org.netbeans.lib.awtextra.AbsoluteConstraints(150, 190, 150, -1));

		jBLFonte.setFont(new java.awt.Font("Dialog", 2, 10)); //$NON-NLS-1$
		jBLFonte.setText(Messages.getString("BoiteDialogueChoroCouleur.135")); //$NON-NLS-1$

		jPanel5.add(jBLFonte, new org.netbeans.lib.awtextra.AbsoluteConstraints(70, 190, 70, -1));

		jTabbedPane1.addTab(Messages.getString("BoiteDialogueChoroCouleur.136"), jPanel5); //$NON-NLS-1$

		getContentPane().add(jTabbedPane1, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 0, 402, 280));

		jrbcm1.setSelected(false);
		jrbcm1.setFont(new java.awt.Font("Dialog", 0, 10));
		jrbcm1.setText(Messages.getString("BoiteDialogueChoroCouleur.145"));
		bgcm.add(jrbcm1);

		getContentPane().add(jrbcm1, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 272, -1, -1));

		jrbcm2.setSelected(false);
		jrbcm2.setFont(new java.awt.Font("Dialog", 0, 10));
		jrbcm2.setText(Messages.getString("BoiteDialogueChoroCouleur.146"));
		bgcm.add(jrbcm2);
		
		getContentPane().add(jrbcm2, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 290, -1, -1));

		jrbcm3.setSelected(true);
		jrbcm3.setFont(new java.awt.Font("Dialog", 0, 10));
		jrbcm3.setText(Messages.getString("BoiteDialogueChoroCouleur.147"));
		bgcm.add(jrbcm3);

		getContentPane().add(jrbcm3, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 308, -1, -1));

		jBOk.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jBOk.setText(Messages.getString("BoiteDialogueChoroCouleur.138")); //$NON-NLS-1$
		jBOk.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				jBOkActionPerformed(evt);
			}
		});

		getContentPane().add(jBOk, new org.netbeans.lib.awtextra.AbsoluteConstraints(330, 290, -1, -1));

		jBAnnuler.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		jBAnnuler.setText(Messages.getString("BoiteDialogueChoroCouleur.140")); //$NON-NLS-1$
		jBAnnuler.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				jBAnnulerActionPerformed(evt);
			}
		});
		jBAnnuler.setDefaultCapable(true);
		getContentPane().add(jBAnnuler, new org.netbeans.lib.awtextra.AbsoluteConstraints(250, 290, -1, -1));

		if (tempCarte.analysePlages.champNum == -1) { //Sélection du premier champ
			for (i = 0; i < colonnes.size(); i++) {
				if (jComboBox1.getItemAt(0).equals(((champDonnees) colonnes.elementAt(i)).nom)) {
					champSelectionne = i;
					tempCarte.analysePlages.champNum = i;
					break;
				}
			}
		}
		java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
		setBounds((screenSize.width - 400) / 2, (screenSize.height - 360) / 2, 400, 360);
	}

	private void jauneSliderStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_bleuSliderStateChanged
		jauneLabel.setText(form.format((double)jauneSlider.getValue() / 255));
		changeCouleurCaissonSelectionne();
	}

	private void jBAnnulerActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
		tempCarte = null;
		setVisible(false);
		dispose();
	}

	private void jBDBleuActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
		getCaisson(1).setBackground(new Color(230, 240, 255));
		((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(0)).couleur = getCaisson(1).getBackground();
		getCaisson(tempCarte.analysePlages.nbreClasses).setBackground(new Color(0, 40, 80));
		((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(tempCarte.analysePlages.nbreClasses - 1)).couleur = getCaisson(tempCarte.analysePlages.nbreClasses)
		.getBackground();
		jBDegrade.doClick();
	}

	private void jBDegradeActionPerformed(java.awt.event.ActionEvent evt) {
		//Dégradé de couleurs entre les deux couleurs extrémes existantes
		int i = 0;
		int c1R = Caisson1.getBackground().getRed();
		int c1V = Caisson1.getBackground().getGreen();
		int c1B = Caisson1.getBackground().getBlue();
		int degradeRouge = (getCaisson(tempCarte.analysePlages.nbreClasses).getBackground().getRed() - c1R);
		int degradeVert = (getCaisson(tempCarte.analysePlages.nbreClasses).getBackground().getGreen() - c1V);
		int degradeBleu = (getCaisson(tempCarte.analysePlages.nbreClasses).getBackground().getBlue() - c1B);
		float cR = degradeRouge / tempCarte.analysePlages.nbreClasses;
		float cV = degradeVert / tempCarte.analysePlages.nbreClasses;
		float cB = degradeBleu / tempCarte.analysePlages.nbreClasses;
		for (i = 1; i < (tempCarte.analysePlages.nbreClasses - 1); i++) {
			int nR = (int) (c1R + (cR * i));
			int nV = (int) (c1V + (cV * i));
			int nB = (int) (c1B + (cB * i));
			Color couleur = new Color(nR, nV, nB);
			getCaisson(i + 1).setBackground(couleur);
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(i)).couleur = couleur;

		}
		changeCurseurs();
	}

	private void jBDGrisActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
		getCaisson(1).setBackground(new Color(240, 240, 240));
		((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(0)).couleur = getCaisson(1).getBackground();
		getCaisson(tempCarte.analysePlages.nbreClasses).setBackground(new Color(40, 40, 40));
		((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(tempCarte.analysePlages.nbreClasses - 1)).couleur = getCaisson(tempCarte.analysePlages.nbreClasses)
		.getBackground();
		jBDegrade.doClick();
	}

	private void jBDRougeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
		getCaisson(1).setBackground(new Color(255, 255, 200));
		((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(0)).couleur = getCaisson(1).getBackground();
		getCaisson(tempCarte.analysePlages.nbreClasses).setBackground(new Color(100, 0, 0));
		((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(tempCarte.analysePlages.nbreClasses - 1)).couleur = getCaisson(tempCarte.analysePlages.nbreClasses)
		.getBackground();
		jBDegrade.doClick();
	}

	private void jBDVertActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
		getCaisson(1).setBackground(new Color(255, 255, 200));
		((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(0)).couleur = getCaisson(1).getBackground();
		getCaisson(tempCarte.analysePlages.nbreClasses).setBackground(new Color(40, 80, 40));
		((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(tempCarte.analysePlages.nbreClasses - 1)).couleur = getCaisson(tempCarte.analysePlages.nbreClasses)
		.getBackground();
		jBDegrade.doClick();
	}

	private void jBGraphiqueActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
		BoiteDialogueGraphique bdGraphique = new BoiteDialogueGraphique(base, true, tempCarte, colonnes, data);
		bdGraphique.setLocationRelativeTo(this);
		bdGraphique.setVisible(true);
	}

	private void jBInversionActionPerformed(java.awt.event.ActionEvent evt) {
		int i = 0;
		int nCls = tempCarte.analysePlages.nbreClasses;
		for (i = nCls; i >= (nCls / 2) + 1; i--) {
			int inverse = tempCarte.analysePlages.nbreClasses - (i - 1);
			Color couleur = getCaisson(i).getBackground();
			getCaisson(i).setBackground(getCaisson(inverse).getBackground());
			getCaisson(inverse).setBackground(couleur);
		}
		changeCurseurs();
	}

	private void jBLAutoActionPerformed(java.awt.event.ActionEvent evt) {
		legendeAuto();
	}

	private void jBOkActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
		genereCarte();
	}

	private void jComboBox1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBox1ActionPerformed
		int i = 0;
		for (i = 0; i < colonnes.size(); i++) {
			if (jComboBox1.getSelectedItem().toString().equals(((champDonnees) colonnes.elementAt(i)).nom)) {
				tempCarte.analysePlages.champNum = i;
				break;
			}
		}
		goDisec();
	}

	private void jrbc1MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jrbc1MouseClicked
		caissonSelectionne = 1;
		changeCurseurs();
	}

	private void jrbc2MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jrbc2MouseClicked
		caissonSelectionne = 2;
		changeCurseurs();
	}

	private void jrbc3MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jrbc3MouseClicked
		if (tempCarte.analysePlages.nbreClasses < 3)
			return;
		caissonSelectionne = 3;
		changeCurseurs();
	}

	private void jrbc4MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jrbc4MouseClicked
		if (tempCarte.analysePlages.nbreClasses < 4)
			return;
		caissonSelectionne = 4;
		changeCurseurs();
	}

	private void jrbc5MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jrbc5MouseClicked
		if (tempCarte.analysePlages.nbreClasses < 5)
			return;
		caissonSelectionne = 5;
		changeCurseurs();
	}

	private void jrbc6MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jrbc6MouseClicked
		if (tempCarte.analysePlages.nbreClasses < 6)
			return;
		caissonSelectionne = 6;
		changeCurseurs();
	}

	private void jrbc7MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jrbc7MouseClicked
		if (tempCarte.analysePlages.nbreClasses < 7)
			return;
		caissonSelectionne = 7;
		changeCurseurs();
	}

	private void jrbc8MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jrbc8MouseClicked
		if (tempCarte.analysePlages.nbreClasses < 8)
			return;
		caissonSelectionne = 8;
		changeCurseurs();
	}

	private void jSlider1StateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jSlider1StateChanged
		int i = 0;
		nbClassesLabel.setText(String.valueOf(jSlider1.getValue()));
		tempCarte.analysePlages.nbreClasses = jSlider1.getValue();
		goDisec();
		for (i = 1; i <= tempCarte.analysePlages.nbreClasses; i++) {
			getCaisson(i).setEnabled(true);
			getCaisson(i).setOpaque(true);
			getjRB(i).setEnabled(true);
			getjTFL(i).setEnabled(true);
			getjLL(i).setEnabled(true);
			getjLD(i).setEnabled(true);
			getjTFcmin(i).setEnabled(true);
			getjTFcmax(i).setEnabled(true);
			getjLN(i).setEnabled(true);
			getjLP(i).setEnabled(true);
		}
		for (i = 8; i > tempCarte.analysePlages.nbreClasses; i--) {
			getCaisson(i).setEnabled(false);
			getCaisson(i).setOpaque(false);
			getjRB(i).setEnabled(false);
			getjTFL(i).setEnabled(false);
			getjLL(i).setEnabled(false);
			getjLD(i).setEnabled(false);
			getjTFcmin(i).setEnabled(false);
			getjTFcmax(i).setEnabled(false);
			getjLN(i).setEnabled(false);
			getjLP(i).setEnabled(false);
		}
	}

	private void jTextField15ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextField15ActionPerformed

	}

	private void jTextField1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextField1ActionPerformed

	}

	private void jtfc8minActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jtfc8minActionPerformed

	}

	private void legendeAuto() {
		int i = 0;
		String debut;
		String bout;
		int nbCl = tempCarte.analysePlages.nbreClasses;
		for (i = 0; i < (nbCl); i++) {
			debut = Messages.getString("BoiteDialogueChoroCouleur.141") + String.valueOf(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(i)).limiteInf) + Messages.getString("BoiteDialogueChoroCouleur.142"); //$NON-NLS-1$ //$NON-NLS-2$
			bout = String.valueOf(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(i)).limiteSup);
			getjTFL(i + 1).setText(debut + bout);
			((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(i)).titreLeg = debut + bout;
		}
	}

	private void magentaSliderStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_vertSliderStateChanged
		magentaLabel.setText(form.format((double)magentaSlider.getValue() / 255));
		changeCouleurCaissonSelectionne();
	}

	private void majAffichageClasses() {
		int i = 0;
		for (i = 1; i < tempCarte.analysePlages.nbreClasses + 1; i++) {
			getjTFcmin(i).setText(String.valueOf(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(i - 1)).limiteInf));
			getjTFcmax(i).setText(String.valueOf(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(i - 1)).limiteSup));
			getjLN(i).setText(String.valueOf(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(i - 1)).nbreIndividus));
			getjLP(i).setText(String.valueOf(((ClasseDiscret) tempCarte.analysePlages.classes.elementAt(i - 1)).partIndividus));
		}
		//legendeAuto();
	}

	private void noirSliderStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_bleuSliderStateChanged
		noirLabel.setText(form.format((double)noirSlider.getValue() / 255));
		changeCouleurCaissonSelectionne();
	}

}